// Expersiones regulares para detectar y remplazar textos
var templateUrlRegex = /templateUrl\s*:(\s*['"`](.*?)['"`]\s*)/gm;
var stylesRegex = /styleUrls *:(\s*\[[^\]]*?\])/g;
var stringRegex = /(['`"])((?:[^\\]\\\1|.)*?)\1/g;

module.exports.translate = function(load) {

    // Parseo la URL del elemento usando link auxiliar
    var url = document.createElement('a');
    url.href = load.address;

    // Obtengo la URL separada en niveles
    var basePathParts = url.pathname.split('/');

    // Quito el ultimo nivel (nombre del archivo)
    basePathParts.pop();

    // Obtengo la ruta de donde está el componente
    var basePath = basePathParts.join('/') + '/';

    // Remplazo URLs de templates
    load.source = load.source.replace(templateUrlRegex, function(match, quote, url) {

        // Obtengo URL del match
        var resolvedUrl = url;

        // Unifico el formato, dejando solo el nombre del archivo
        if (resolvedUrl.startsWith('./')) resolvedUrl = resolvedUrl.substr(2);

        // Si la ruta es reativa agrego al path base del componente
        if (!resolvedUrl.startsWith('/')) resolvedUrl = basePath + resolvedUrl;

        // Devuelvo el texto del match reemplazado
        return 'templateUrl: "' + resolvedUrl + '"';

    // Remplazo URLs de estilos
    }).replace(stylesRegex, function(match, relativeUrls) {

        // Obtengo lista de URLs del match
        var urls = [];

        // Recorro la lista de URLs
        while ((match = stringRegex.exec(relativeUrls)) !== null) {

            // Obtengo la URL del estilo
            var styleUrl = match[2];

            // Unifico el formato, dejando solo el nombre del archivo
            if (styleUrl.startsWith('./')) styleUrl = styleUrl.substr(2);

            // Si la ruta es reativa agrego al path base del componente
            if (!styleUrl.startsWith('/')) styleUrl = basePath + styleUrl;

            // Agrego el estilo al array
            urls.push('"' + styleUrl + '"');
        }

        // Devuelvo el texto del match reemplazado
        return "styleUrls: [" + urls.join(', ') + "]";
    });

    return load;
};
