"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MSSql = void 0;
const AuthMSSql = require("./mssql/auth.mssql");
const AuditorEvaluationPlanMSSql = require("./mssql/auditor-evaluation-plan.mssql");
const BatchMSSql = require("./mssql/batch.mssql");
const BatchErrorMSSql = require("./mssql/batch-error.mssql");
const BatchScheduleMSSql = require("./mssql/batch-schedule.mssql");
const CustomFieldMSSql = require("./mssql/custom-field.mssql");
const DiarizationMSSql = require("./mssql/diarization.mssql");
const DictionaryMSSql = require("./mssql/dictionary.mssql");
const DomainMSSql = require("./mssql/domain.mssql");
const EntityMSSql = require("./mssql/entity.mssql");
const EvaluationTipificationMSSql = require("./mssql/evaluation-tipification.mssql");
const GenerativeMSSql = require("./mssql/generative.mssql");
const GenerativeEngineTokenMSSql = require("./mssql/generative-engine-token.mssql");
const GenerativeEngineUsageMSSql = require("./mssql/generative-engine-usage.mssql");
const GenerativeExampleMSSql = require("./mssql/generative-example.mssql");
const GenerativeIntentMSSql = require("./mssql/generative-intent.mssql");
const GenerativeIntentItemMSSql = require("./mssql/generative-intent-item.mssql");
const InteractionEvaluationPlanMSSql = require("./mssql/interaction-evaluation-plan.mssql");
const SentimentMSSql = require("./mssql/sentiment.mssql");
const TeamPerformanceMSSql = require("./mssql/team-performance.mssql");
const TipificationMSSql = require("./mssql/tipification.mssql");
const VCCMSSql = require("./mssql/vcc.mssql");
const VCCLicenseMSSql = require("./mssql/vcc-license.mssql");
const HomeMSSql = require("./mssql/home.mssql");
const NotificationMSSql = require("./mssql/notification.mssql");
const ProfileImageMSSql = require("./mssql/profile-image.mssql");
const ReportMSSql = require("./mssql/report.mssql");
const RoleMSSql = require("./mssql/role.mssql");
const UserMSSql = require("./mssql/user.mssql");
const ApiUserMSSql = require("./mssql/api-user.mssql");
const AzureSubscriptionMSSql = require("./mssql/azure-subscription.mssql");
const ClientMSSql = require("./mssql/client.mssql");
const ProcessMSSql = require("./mssql/process.mssql");
const EnvironmentMSSql = require("./mssql/environment.mssql");
const AllegroMSSql = require("./mssql/allegro.mssql");
const AudiosMSSql = require("./mssql/audio.mssql");
const IdathaMSSql = require("./mssql/idatha.mssql");
const FeelingMSSql = require("./mssql/feeling.mssql");
const CategoryMSSql = require("./mssql/category.mssql");
const NeuroLinguisticProgrammingMSSql = require("./mssql/neuro-linguistic-programming.mssql");
const TemplateMSSql = require("./mssql/template.mssql");
const CustomTemplateMSSql = require("./mssql/custom-template.mssql");
const GenericTemplateMSSql = require("./mssql/generic-template.mssql");
const GenericQueryMSSql = require("./mssql/generic-query.mssql");
const NLUMSSql = require("./mssql/nlu.mssql");
const IntentMSSql = require("./mssql/intent.mssql");
const UtteranceMSSql = require("./mssql/utterance.mssql");
const CommentMSSql = require("./mssql/tag.mssql");
const StudyMSSql = require("./mssql/study.mssql");
const WordBlacklistMSSql = require("./mssql/word-blacklist.mssql");
const TagMSSql = require("./mssql/tag.mssql");
const IntegrationMSSql = require("./mssql/integration.mssql");
const CampaignFulfillmentMSSql = require("./mssql/campaign-fulfillment.mssql");
const AverageGroupRatingMSSql = require("./mssql/average-group-rating.mssql");
const AverageGroupRatingNormMSSql = require("./mssql/average-group-rating-norm.mssql");
const TopBestAgentsMSSql = require("./mssql/top-best-agents.mssql");
const TopWorstAgentsMSSql = require("./mssql/top-worst-agents.mssql");
const InteractionsByTypeMSSql = require("./mssql/interactions-by-type.mssql");
const AbilityMSSql = require("./mssql/ability.mssql");
const SubgroupMSSql = require("./mssql/subgroup.mssql");
const GroupMSSql = require("./mssql/group.mssql");
const ExceptionMSSql = require("./mssql/exception.mssql");
const EvaluationFormatMSSql = require("./mssql/evaluation-format.mssql");
const CampainMSSql = require("./mssql/campain.mssql");
const InteractionMSSql = require("./mssql/interaction.mssql");
const EvaluationPlanMSSql = require("./mssql/evaluation-plan.mssql");
const InteractionTypeMSSql = require("./mssql/interaction-type.mssql");
const EvaluationMSSql = require("./mssql/evaluation.mssql");
const EvaluationReviewMSSql = require("./mssql/evaluation-review.mssql");
const AuditorMSSql = require("./mssql/auditor.mssql");
const AgentMSSql = require("./mssql/agent.mssql");
const RealtimeEvaluationPlanMSSql = require("./mssql/realtime-evaluation-plan.mssql");
const SupervisorMSSql = require("./mssql/supervisor.mssql");
const VersionMSSql = require("./mssql/version.mssql");
const TenantVCCMSSql = require("./mssql/tenant-vcc.mssql");
const AsyncInteractionMSSql = require("./mssql/async-interaction.mssql");
const DispositionCodeMSSql = require("./mssql/disposition-code.mssql");
const GlobalSearchMSSql = require("./mssql/global-search.mssql");
const WorkGroupSupervisorMSSql = require("./mssql/workgroupsupervisor.mssql");
let MSSql = {};
exports.MSSql = MSSql;
Object.assign(MSSql, AuthMSSql, AuditorEvaluationPlanMSSql, BatchMSSql, BatchErrorMSSql, BatchScheduleMSSql, CustomFieldMSSql, DiarizationMSSql, DictionaryMSSql, DomainMSSql, EntityMSSql, EvaluationTipificationMSSql, GenerativeMSSql, GenerativeEngineTokenMSSql, GenerativeEngineUsageMSSql, GenerativeExampleMSSql, GenerativeIntentMSSql, GenerativeIntentItemMSSql, InteractionEvaluationPlanMSSql, RealtimeEvaluationPlanMSSql, SentimentMSSql, TeamPerformanceMSSql, TipificationMSSql, VCCMSSql, VCCLicenseMSSql, HomeMSSql, NotificationMSSql, ProfileImageMSSql, ReportMSSql, RoleMSSql, ApiUserMSSql, AzureSubscriptionMSSql, UserMSSql, ClientMSSql, ProcessMSSql, EnvironmentMSSql, AllegroMSSql, AudiosMSSql, IdathaMSSql, FeelingMSSql, CategoryMSSql, NeuroLinguisticProgrammingMSSql, TemplateMSSql, CustomTemplateMSSql, GenericTemplateMSSql, GenericQueryMSSql, NLUMSSql, IntentMSSql, UtteranceMSSql, CommentMSSql, StudyMSSql, WordBlacklistMSSql, TagMSSql, IntegrationMSSql, CampaignFulfillmentMSSql, AverageGroupRatingMSSql, AverageGroupRatingNormMSSql, TopBestAgentsMSSql, TopWorstAgentsMSSql, InteractionsByTypeMSSql, AbilityMSSql, SubgroupMSSql, GroupMSSql, ExceptionMSSql, EvaluationFormatMSSql, CampainMSSql, DispositionCodeMSSql, InteractionMSSql, EvaluationPlanMSSql, InteractionTypeMSSql, EvaluationMSSql, EvaluationReviewMSSql, AuditorMSSql, AgentMSSql, VersionMSSql, ApiUserMSSql, SupervisorMSSql, TenantVCCMSSql, AsyncInteractionMSSql, GlobalSearchMSSql, WorkGroupSupervisorMSSql);
