"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.FinishedBatchClose = exports.SaveBatchStatus = exports.GetFinishedBatch = exports.GetBatchDetail = exports.BatchMSSql = void 0;
const log4js = require("log4js");
let sql = require('mssql');
let logger = log4js.getLogger('Sql');
let sqlConn;
function BatchMSSql(app) {
    sqlConn = app.get('sqlConn');
}
exports.BatchMSSql = BatchMSSql;
function GetBatchDetail(vcc, batchTypeName, batchTypeId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('BatchTypeName', sql.VarChar(50), batchTypeName)
        .input('BatchTypeId', sql.VarChar(50), batchTypeId)
        .execute('GetBatchDetail')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let batchDetail = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(batchDetail);
    })
        .catch((err) => {
        let errorMsg = (err && err.procName ? 'Error on \'' + err.procName + '\': ' : 'Executing error ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetBatchDetail = GetBatchDetail;
function GetFinishedBatch() {
    return new sql.Request(sqlConn)
        .execute('GetFinishedBatch')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        return Promise.resolve(recordset);
    })
        .catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetFinishedBatch = GetFinishedBatch;
function SaveBatchStatus(vcc, batchTypeId, systemService, status) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('BatchTypeId', sql.VarChar(50), batchTypeId)
        .input('SystemService', sql.VarChar(50), systemService)
        .input('Status', sql.VarChar(50), status)
        .execute('SaveBatchStatus')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error on \'' + err.procName + '\': ' : 'Executing error ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.SaveBatchStatus = SaveBatchStatus;
function FinishedBatchClose(vcc, batchTypeName, batchTypeId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('BatchTypeName', sql.VarChar(50), batchTypeName)
        .input('BatchTypeId', sql.VarChar(50), batchTypeId)
        .execute('FinishedBatchClose')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        return Promise.resolve(recordset);
    })
        .catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.FinishedBatchClose = FinishedBatchClose;
