"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.LaunchAudioConverter = exports.DiarizationMSSql = void 0;
const log4js = require("log4js");
let sql = require('mssql');
let logger = log4js.getLogger('Sql');
let sqlConn;
function DiarizationMSSql(app) {
    sqlConn = app.get('sqlConn');
}
exports.DiarizationMSSql = DiarizationMSSql;
function LaunchAudioConverter(vcc, appPath, inputFilePath, outputFolderPath, remoteRepoDiarizationPath) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('APP_PATH', sql.VarChar(250), appPath)
        .input('INPUT_FILE_PATH', sql.VarChar(250), inputFilePath)
        .input('OUTPUT_FOLDER_PATH', sql.VarChar(250), outputFolderPath)
        .input('REMOTE_REPO_DIARIZATION_PATH', sql.VarChar(250), remoteRepoDiarizationPath)
        .execute('LaunchAudioConverter')
        .then((sqlResult) => {
        let recordset = (remoteRepoDiarizationPath === 'local') ?
            (sqlResult.recordsets?.length > 1 ? sqlResult.recordsets[1] : null)
            :
                (sqlResult.recordsets?.length > 2 ? sqlResult.recordsets[2] : null);
        let errCodeLine = recordset && recordset.length && recordset.length > 3 ? recordset[recordset.length - 2] : null;
        logger.debug('MSSQL: result from LaunchAudioConverter SP: ', recordset);
        logger.debug('MSSQL: result from LaunchAudioConverter SP: ', errCodeLine);
        logger.debug('MSSQL: result from LaunchAudioConverter SP: ' + errCodeLine);
        logger.debug('MSSQL: result from LaunchAudioConverter SP: ', errCodeLine.output);
        let regex = new RegExp(`(?<=^ErrCode\\:\\s).*(?=$)`, 'g');
        logger.debug('MSSQL: result from LaunchAudioConverter SP: ', errCodeLine.output.match(regex));
        let objectResult = {
            errcode: Number(errCodeLine.output.match(regex)[0])
        };
        return Promise.resolve(objectResult);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.LaunchAudioConverter = LaunchAudioConverter;
