"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SaveEvaluationFormatAttachedSignature = exports.GetEvaluationFormatAttachedSignatures = exports.SaveEvaluationFormatAbilityScoreTipificationItem = exports.SaveEvaluationFormatAbilityScoreTipificationQuery = exports.SaveEvaluationFormatAbilityScoreTipification = exports.GetEvaluationFormatCustomFields = exports.SaveEvaluationFormatCustomField = exports.IsTemplateBeingUsedByQuality = exports.IsQueryBeingUsedByQuality = exports.GetEvaluationFormatQualificationAverage = exports.DeleteEvaluationFormat = exports.DeleteEvaluationFormatContent = exports.GetCampainEvaluationFormats = exports.GetAbilityEvaluationFormats = exports.GetEvaluationFormat = exports.SaveCampainEvaluationFormat = exports.SaveAbilityEvaluationFormat = exports.SaveEvaluationFormat = exports.GetEvaluationFormatDescription = exports.GetEvaluationFormatDescriptionsBySearchCriteria = exports.GetEvaluationFormatsFromHistoricEvaluationPlans = exports.GetEvaluationFormats = exports.EvaluationFormatMSSql = void 0;
const log4js = require("log4js");
let sql = require('mssql');
const score_model_1 = require("../../models/score.model");
let logger = log4js.getLogger('Sql');
let sqlConn;
function EvaluationFormatMSSql(app) {
    sqlConn = app.get('sqlConn');
}
exports.EvaluationFormatMSSql = EvaluationFormatMSSql;
function GetEvaluationFormats(instance, search_criteria, search_expression, disabled) {
    logger.info('[EvaluationFormatMSSql::GetEvaluationFormats] Received Instance: ' + instance);
    logger.info('[EvaluationFormatMSSql::GetEvaluationFormats] Received search_criteria: ' + search_criteria);
    logger.info('[EvaluationFormatMSSql::GetEvaluationFormats] Received search_expression: ' + search_expression);
    logger.info('[EvaluationFormatMSSql::GetEvaluationFormats] Calling SP GetEvaluationFormats');
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('SearchCriteria', sql.VarChar(50), search_criteria)
        .input('SearchExpression', sql.VarChar(50), search_expression)
        .input('Disabled', sql.Bit(), disabled)
        .execute('GetEvaluationFormats')
        .then((sqlResult) => {
        logger.info('[EvaluationFormatMSSql::GetEvaluationFormats] Received result from SP GetEvaluationFormats: ' + sqlResult.recordsets.length);
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error on \'' + err.procName + '\': ' : 'Executing request: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error('[EvaluationFormatMSSql::GetEvaluationFormats] ' + errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluationFormats = GetEvaluationFormats;
function GetEvaluationFormatsFromHistoricEvaluationPlans(vcc) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .execute('GetEvaluationFormatsFromHistoricEvaluationPlans')
        .then((sqlResult) => {
        logger.info('[EvaluationFormatMSSql::GetEvaluationFormatsFromHistoricEvaluationPlans] Received result: ' + sqlResult.recordsets.length);
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error on \'' + err.procName + '\': ' : 'Requesting error: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error('[EvaluationFormatMSSql::GetEvaluationFormatsFromHistoricEvaluationPlans] ' + errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluationFormatsFromHistoricEvaluationPlans = GetEvaluationFormatsFromHistoricEvaluationPlans;
function GetEvaluationFormatDescriptionsBySearchCriteria(instance, search_criteria, search_expression) {
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('SearchCriteria', sql.VarChar(50), search_criteria)
        .input('SearchExpression', sql.VarChar(50), search_expression)
        .execute('GetEvaluationFormatDescriptionsBySearchCriteria')
        .then((sqlResult) => {
        logger.info('[EvaluationFormatMSSql::GetEvaluationFormatDescriptionsBySearchCriteria] Received result from SP GetEvaluationFormatDescriptionsBySearchCriteria: ' + sqlResult.recordsets.length);
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error on \'' + err.procName + '\': ' : 'Requesting error: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error('[EvaluationFormatMSSql::GetEvaluationFormatDescriptionsBySearchCriteria] ' + errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluationFormatDescriptionsBySearchCriteria = GetEvaluationFormatDescriptionsBySearchCriteria;
function GetEvaluationFormatDescription(instance, description) {
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('Description', sql.VarChar(50), description)
        .execute('GetEvaluationFormatDescription')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let evaluationFormat = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(evaluationFormat);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluationFormatDescription = GetEvaluationFormatDescription;
function SaveEvaluationFormat(instance, id, description, type, environmentType, executionType, minQualificationAcceptable, minAutomaticQualification, managementFormURL, createdDate, createdByUserId, lastModifiedDate, lastModifiedByUserId, enabled, templateId) {
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('ID', sql.VarChar(50), id)
        .input('Description', sql.VarChar(100), description)
        .input('Type', sql.VarChar(100), type)
        .input('EnvironmentType', sql.VarChar(50), environmentType)
        .input('ExecutionType', sql.VarChar(25), executionType)
        .input('MinQualificationAcceptable', sql.Numeric(5, 2), minQualificationAcceptable)
        .input('MinAutomaticQualification', sql.Numeric(5, 2), minAutomaticQualification)
        .input('ManagementFormURL', sql.VarChar(1000), managementFormURL)
        .input('CreatedDate', sql.DateTime, createdDate)
        .input('CreatedByUserId', sql.VarChar(50), createdByUserId)
        .input('LastModifiedDate', sql.DateTime, lastModifiedDate)
        .input('LastModifiedByUserId', sql.VarChar(50), lastModifiedByUserId)
        .input('Enabled', sql.VarChar(50), enabled)
        .input('templateId', sql.VarChar(50), templateId)
        .execute('SaveEvaluationFormat')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.SaveEvaluationFormat = SaveEvaluationFormat;
function SaveAbilityEvaluationFormat(instance, idEvaluationFormat, idAbility, idGroup, idSubGroup, penalizes, score, order, conditional, helpComment) {
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('IdEvaluationFormat', sql.VarChar(50), idEvaluationFormat)
        .input('IdAbility', sql.VarChar(50), idAbility)
        .input('IdGroup', sql.VarChar(50), idGroup)
        .input('IdSubGroup', sql.VarChar(50), idSubGroup)
        .input('Score', sql.Numeric(5, 2), score)
        .input('Penalizes', sql.VarChar(3), penalizes)
        .input('Order', sql.Numeric(5, 0), order)
        .input('Conditional', sql.VarChar(50), conditional)
        .input('HelpComment', sql.VarChar(250), helpComment)
        .execute('SaveAbilityEvaluationFormat')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.SaveAbilityEvaluationFormat = SaveAbilityEvaluationFormat;
function SaveCampainEvaluationFormat(instance, idEvaluationFormat, idCampain) {
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('IdEvaluationFormat', sql.VarChar(50), idEvaluationFormat)
        .input('IdCampaign', sql.VarChar(100), idCampain)
        .execute('SaveCampaignEvaluationFormat')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.SaveCampainEvaluationFormat = SaveCampainEvaluationFormat;
function GetEvaluationFormat(instance, idEvaluationFormat, evaluationPlanId = null) {
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('ID', sql.VarChar(50), idEvaluationFormat)
        .input('EvaluationPlanId', sql.VarChar(50), evaluationPlanId)
        .execute('GetEvaluationFormat')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let evaluationFormat = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(evaluationFormat);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluationFormat = GetEvaluationFormat;
function GetAbilityEvaluationFormats(vcc, idEvaluationFormat, evaluationPlanId = null) {
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), vcc)
        .input('IdEvaluationFormat', sql.VarChar(50), idEvaluationFormat)
        .input('EvaluationPlanId', sql.VarChar(50), evaluationPlanId)
        .execute('GetAbilityEvaluationFormats')
        .then((sqlResult) => {
        let abilityEvaluationFormatRecordset = sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null;
        let abilityScoreRecordset = sqlResult.recordsets?.length > 1 ? sqlResult.recordsets[1] : null;
        let abilityScoreTipificationRecordset = sqlResult.recordsets?.length > 2 ? sqlResult.recordsets[2] : null;
        let abilityScoreTipificationQueryRecordset = sqlResult.recordsets?.length > 3 ? sqlResult.recordsets[3] : null;
        let abilityScoreTipificationItemRecordset = sqlResult.recordsets?.length > 4 ? sqlResult.recordsets[4] : null;
        abilityScoreTipificationRecordset.forEach(ast => {
            ast.tipificationQuery = abilityScoreTipificationQueryRecordset.find(astq => astq.tipificationId === ast.id) || new score_model_1.ScoreTipificationQuery();
            ast.items = abilityScoreTipificationItemRecordset.filter(asti => ast.scoreId === asti.scoreId && asti.tipificationId === ast.id);
        });
        abilityScoreRecordset.forEach(as => {
            as.tipifications = abilityScoreTipificationRecordset.filter(ast => ast.scoreId === as.id);
        });
        abilityEvaluationFormatRecordset.forEach(aef => {
            aef.scores = abilityScoreRecordset.filter(as => as.abilityId === aef.idAbility);
        });
        return Promise.resolve(abilityEvaluationFormatRecordset);
    })
        .catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetAbilityEvaluationFormats = GetAbilityEvaluationFormats;
function GetCampainEvaluationFormats(instance, idEvaluationFormat, evaluationPlanId = null) {
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('IdEvaluationFormat', sql.VarChar(50), idEvaluationFormat)
        .input('EvaluationPlanId', sql.VarChar(50), evaluationPlanId)
        .execute('GetCampaignEvaluationFormats')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetCampainEvaluationFormats = GetCampainEvaluationFormats;
function DeleteEvaluationFormatContent(vcc, evaluationFormatId, templateId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('EvaluationFormatId', sql.VarChar(50), evaluationFormatId)
        .input('TemplateId', sql.VarChar(50), templateId)
        .execute('DeleteEvaluationFormatContent')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    })
        .catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.DeleteEvaluationFormatContent = DeleteEvaluationFormatContent;
function DeleteEvaluationFormat(instance, idEvaluationFormat) {
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('ID', sql.VarChar(50), idEvaluationFormat)
        .execute('DeleteEvaluationFormat')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.DeleteEvaluationFormat = DeleteEvaluationFormat;
function GetEvaluationFormatQualificationAverage(instance, idEvaluationFormat) {
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('IdEvaluationFormat', sql.VarChar(50), idEvaluationFormat)
        .execute('GetEvaluationFormatQualificationAverage')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluationFormatQualificationAverage = GetEvaluationFormatQualificationAverage;
function IsQueryBeingUsedByQuality(instance, queryName) {
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('queryName', sql.VarChar(50), queryName)
        .execute('IsQueryBeingUsedByQuality')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.IsQueryBeingUsedByQuality = IsQueryBeingUsedByQuality;
function IsTemplateBeingUsedByQuality(instance, queryName) {
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('templateId', sql.VarChar(50), queryName)
        .execute('isTemplateBeingUsedByQuality')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.IsTemplateBeingUsedByQuality = IsTemplateBeingUsedByQuality;
function SaveEvaluationFormatCustomField(vcc, id, evaluationFormatId, customFieldId, order, userId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('ID', sql.VarChar(50), id)
        .input('EvaluationFormatId', sql.VarChar(50), evaluationFormatId)
        .input('CustomFieldId', sql.VarChar(100), customFieldId)
        .input('Order', sql.Int, order)
        .input('CreatedByUserId', sql.VarChar(50), userId)
        .input('LastModifiedByUserId', sql.VarChar(50), userId)
        .execute('SaveEvaluationFormatCustomField')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    })
        .catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.SaveEvaluationFormatCustomField = SaveEvaluationFormatCustomField;
function GetEvaluationFormatCustomFields(vcc, evaluationFormatId, evaluationPlanId = null) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('EvaluationFormatId', sql.VarChar(50), evaluationFormatId)
        .input('EvaluationPlanId', sql.VarChar(50), evaluationPlanId)
        .execute('GetEvaluationFormatCustomFields')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        return Promise.resolve(recordset);
    })
        .catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluationFormatCustomFields = GetEvaluationFormatCustomFields;
function SaveEvaluationFormatAbilityScoreTipification(vcc, evaluationFormatId, scoreId, id, description, detail, order, userId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('EvaluationFormatId', sql.VarChar(50), evaluationFormatId)
        .input('ScoreId', sql.VarChar(50), scoreId)
        .input('ID', sql.VarChar(50), id)
        .input('Description', sql.VarChar(250), description)
        .input('Detail', sql.VarChar(500), detail)
        .input('Order', sql.Int, order)
        .input('UserId', sql.VarChar(50), userId)
        .execute('SaveEvaluationFormatAbilityScoreTipification')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let output = (recordset?.length ? recordset[0] : null);
        return Promise.resolve(output?.result === 1);
    })
        .catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.SaveEvaluationFormatAbilityScoreTipification = SaveEvaluationFormatAbilityScoreTipification;
function SaveEvaluationFormatAbilityScoreTipificationQuery(vcc, evaluationFormatId, scoreId, tipificationId, queryId, queryContent, acceptancePercentage, userId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('EvaluationFormatId', sql.VarChar(50), evaluationFormatId)
        .input('ScoreId', sql.VarChar(50), scoreId)
        .input('TipificationId', sql.VarChar(50), tipificationId)
        .input('QueryId', sql.VarChar(50), queryId)
        .input('QueryContent', sql.VarChar(sql.MAX), queryContent)
        .input('AcceptancePercentage', sql.Decimal(18, 2), acceptancePercentage)
        .execute('SaveEvaluationFormatAbilityScoreTipificationQuery')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let output = (recordset?.length ? recordset[0] : null);
        return Promise.resolve(output?.result === 1);
    })
        .catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.SaveEvaluationFormatAbilityScoreTipificationQuery = SaveEvaluationFormatAbilityScoreTipificationQuery;
function SaveEvaluationFormatAbilityScoreTipificationItem(vcc, evaluationFormatId, scoreId, tipificationId, id, secondLevelItemId, description, order, userId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('EvaluationFormatId', sql.VarChar(50), evaluationFormatId)
        .input('ScoreId', sql.VarChar(50), scoreId)
        .input('TipificationId', sql.VarChar(50), tipificationId)
        .input('ID', sql.VarChar(50), id)
        .input('SecondLevelItemId', sql.VarChar(50), secondLevelItemId)
        .input('Description', sql.VarChar(250), description)
        .input('Order', sql.Int, order)
        .input('UserId', sql.VarChar(50), userId)
        .execute('SaveEvaluationFormatAbilityScoreTipificationItem')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let output = (recordset?.length ? recordset[0] : null);
        return Promise.resolve(output?.result === 1);
    })
        .catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.SaveEvaluationFormatAbilityScoreTipificationItem = SaveEvaluationFormatAbilityScoreTipificationItem;
function GetEvaluationFormatAttachedSignatures(vcc, evaluationFormatId, evaluationPlanId = null) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('EvaluationFormatId', sql.VarChar(50), evaluationFormatId)
        .input('EvaluationPlanId', sql.VarChar(50), evaluationPlanId)
        .execute('GetEvaluationFormatAttachedSignatures')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        return Promise.resolve(recordset);
    })
        .catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluationFormatAttachedSignatures = GetEvaluationFormatAttachedSignatures;
function SaveEvaluationFormatAttachedSignature(vcc, evaluationFormatId, description, order, userId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('EvaluationFormatId', sql.VarChar(50), evaluationFormatId)
        .input('Description', sql.VarChar(100), description)
        .input('Order', sql.Int, order)
        .input('CreatedByUserId', sql.VarChar(50), userId)
        .input('LastModifiedByUserId', sql.VarChar(50), userId)
        .execute('SaveEvaluationFormatAttachedSignature')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    })
        .catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.SaveEvaluationFormatAttachedSignature = SaveEvaluationFormatAttachedSignature;
