"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SaveGenerativeEngineUsage = exports.GenerativeEngineUsageMSSql = void 0;
const log4js = require("log4js");
let sql = require('mssql');
let logger = log4js.getLogger('Sql');
let sqlConn;
function GenerativeEngineUsageMSSql(app) {
    sqlConn = app.get('sqlConn');
}
exports.GenerativeEngineUsageMSSql = GenerativeEngineUsageMSSql;
function SaveGenerativeEngineUsage(vcc, evaluationPlanId, interactionId, appId, tokens) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('EvaluationPlanId', sql.VarChar(50), evaluationPlanId)
        .input('InteractionId', sql.VarChar(250), interactionId)
        .input('AppId', sql.VarChar(50), appId)
        .input('Tokens', sql.Int, tokens)
        .execute('SaveGenerativeEngineUsage')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let output = (recordset?.length > 0 ? recordset[0] : null);
        return Promise.resolve(output?.result === 1);
    })
        .catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.SaveGenerativeEngineUsage = SaveGenerativeEngineUsage;
