"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.GetGenerativeIntentItems = exports.GenerativeIntentItemMSSql = void 0;
const log4js = require("log4js");
let sql = require('mssql');
let logger = log4js.getLogger('Sql');
let sqlConn;
function GenerativeIntentItemMSSql(app) {
    sqlConn = app.get('sqlConn');
}
exports.GenerativeIntentItemMSSql = GenerativeIntentItemMSSql;
function GetGenerativeIntentItems(vcc = null, searchCriteria = null, searchExpression = null, intentIds = null) {
    let logLabel = `[GenerativeIntentMSSql::GetGenerativeIntentItems] [vcc => ${vcc}]: `;
    if (searchCriteria && searchExpression)
        logger.info(`${logLabel}[search_criteria::search_expression => ${searchCriteria}::${searchExpression}]`);
    if (intentIds?.length)
        logger.info(`${logLabel}[appIds => ${intentIds}]`);
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('SearchCriteria', sql.VarChar(50), searchCriteria)
        .input('SearchExpression', sql.VarChar(50), searchExpression)
        .execute('GetGenerativeIntentItems')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        logger.info(`${logLabel}getting recordset: `, recordset?.length ? recordset.length : 0);
        return Promise.resolve(recordset);
    })
        .catch((err) => {
        let errorMsg = (err?.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(`${logLabel}getting errorMsg:`, errorMsg);
        return Promise.reject(err);
    });
}
exports.GetGenerativeIntentItems = GetGenerativeIntentItems;
