"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CloseI6InteractionAsyncInteraction = exports.DeleteI6InteractionText = exports.SaveI6InteractionAsyncInteraction = exports.CloseI6InteractionAudio = exports.DeleteI6InteractionAudio = exports.SaveI6InteractionAudio = exports.GetI6InteractionMessages = exports.GetI6InteractionAudios = exports.GetInteractionQueryResults = exports.GetInteractionTranscription = exports.GetAsyncBillingInteractions = exports.BulkBillingInteractions = exports.GetI6TextInteractions = exports.GetI6AlreadyRegisteredTextInteractions = exports.GetI6AlreadyRegisteredCallInteractions = exports.GetI6CallInteractions = exports.GetAllegroInteractions = exports.GetInteractions = exports.GetEvaluationTypesInteraction = exports.GetEvaluatedInteractions = exports.GetEvaluatedInteractionsByCampaignsAuditorsAndAgents = exports.GetEvaluatedInteractionsByAuditor = exports.GetNotEvaluatedInteractionsEfectivityAuditor = exports.GetNotEvaluatedInteractionsAuditor = exports.InteractionMSSql = void 0;
const log4js = require("log4js");
const moment = require("moment");
let sql = require('mssql');
const interaction_model_1 = require("../../models/interaction.model");
let logger = log4js.getLogger('Sql');
let sqlConn;
function InteractionMSSql(app) {
    sqlConn = app.get('sqlConn');
}
exports.InteractionMSSql = InteractionMSSql;
function GetNotEvaluatedInteractionsAuditor(instance, userId, campaigns, agents, evaluationPlans, interactionTypes, interactionResults, dateEvaluationPlanFin, evaluationStatus, interactionIds = '', contactAddress = '', dateIni, dateFin, auditors) {
    logger.info('[InteractionMSSql::GetNotEvaluatedInteractionsAuditor] Calling SP GetNotEvaluatedInteractionsAuditor for VCC: ' + instance);
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('UserId', sql.VarChar(50), userId)
        .input('IdCampaigns', sql.VarChar(sql.MAX), campaigns)
        .input('IdAgents', sql.VarChar(sql.MAX), agents)
        .input('EvaluationPlans', sql.VarChar(sql.MAX), evaluationPlans)
        .input('InteractionTypes', sql.VarChar(100), interactionTypes)
        .input('InteractionResults', sql.VarChar(sql.MAX), interactionResults)
        .input('EvaluationPlanDateTo', sql.VarChar(50), dateEvaluationPlanFin)
        .input('EvaluationStatus', sql.Bit(), evaluationStatus)
        .input('InteractionIds', sql.VarChar(sql.MAX), interactionIds)
        .input('ContactAddress', sql.VarChar(300), contactAddress)
        .input('EvaluationDateFrom', sql.VarChar(300), dateIni)
        .input('EvaluationDateTo', sql.VarChar(300), dateFin)
        .input('IdAuditors', sql.VarChar(sql.MAX), auditors)
        .execute('GetNotEvaluatedInteractionsAuditor')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        logger.info('[InteractionMSSql::GetNotEvaluatedInteractionsAuditor] Received result from SP GetNotEvaluatedInteractionsAuditor: ' + sqlResult.recordsets.length);
        return Promise.resolve(recordset);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error on \'' + err.procName + '\': ' : 'Error executing: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error('[InteractionMSSql::GetNotEvaluatedInteractionsAuditor] ' + errorMsg);
        return Promise.reject(err);
    });
}
exports.GetNotEvaluatedInteractionsAuditor = GetNotEvaluatedInteractionsAuditor;
function GetNotEvaluatedInteractionsEfectivityAuditor(instance, userId, campaigns, agents, evaluationPlans, interactionTypes, interactionResults, dateEvaluationPlanFin, evaluationStatus, interactionIds = '', contactAddress = '', efectivityPlans = '', dateIni, dateFin) {
    logger.info('[InteractionMSSql::GetNotEvaluatedInteractionsEfectivityAuditor] Calling SP GetNotEvaluatedInteractionsEfectivityAuditor for VCC: ' + instance);
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('UserId', sql.VarChar(50), userId)
        .input('IdCampaigns', sql.VarChar(sql.MAX), campaigns)
        .input('IdAgents', sql.VarChar(sql.MAX), agents)
        .input('EvaluationPlans', sql.VarChar(sql.MAX), evaluationPlans)
        .input('InteractionTypes', sql.VarChar(100), interactionTypes)
        .input('InteractionResults', sql.VarChar(sql.MAX), interactionResults)
        .input('EvaluationPlanDateTo', sql.VarChar(50), dateEvaluationPlanFin)
        .input('EvaluationStatus', sql.Bit(), evaluationStatus)
        .input('InteractionIds', sql.VarChar(sql.MAX), interactionIds)
        .input('ContactAddress', sql.VarChar(300), contactAddress)
        .input('EfectivityPlans', sql.VarChar(sql.MAX), efectivityPlans)
        .input('EvaluationDateFrom', sql.VarChar(300), dateIni)
        .input('EvaluationDateTo', sql.VarChar(300), dateFin)
        .execute('GetNotEvaluatedInteractionsEfectivityAuditor')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        logger.info('[InteractionMSSql::GetNotEvaluatedInteractionsEfectivityAuditor] Received result from SP GetNotEvaluatedInteractionsEfectivityAuditor: ' + sqlResult.recordsets.length);
        return Promise.resolve(recordset);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error on \'' + err.procName + '\': ' : 'Error executing: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error('[InteractionMSSql::GetNotEvaluatedInteractionsEfectivityAuditor] ' + errorMsg);
        return Promise.reject(err);
    });
}
exports.GetNotEvaluatedInteractionsEfectivityAuditor = GetNotEvaluatedInteractionsEfectivityAuditor;
function GetEvaluatedInteractionsByAuditor(instance, auditorIds, agentIds, campaignIds, evaluationPlanIds, evaluationDateFrom, evaluationDateTo, evaluationHourFrom, evaluationHourTo, interactionMinDuration, interactionMaxDuration, interactionOrigins, interactionResults, evaluationTypes, interactionTags, interactionFormats, interactionIds = '') {
    logger.info('[InteractionMSSql::GetEvaluatedInteractionsByAuditor] Calling GetEvaluatedInteractionsByAuditor SP');
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('IdAuditor', sql.VarChar(sql.MAX), auditorIds)
        .input('IdAgent', sql.VarChar(sql.MAX), agentIds)
        .input('IdCampaign', sql.VarChar(sql.MAX), campaignIds)
        .input('IdEvaluationPlan', sql.VarChar(sql.MAX), evaluationPlanIds)
        .input('EvaluationDateFrom', sql.VarChar(50), evaluationDateFrom)
        .input('EvaluationDateTo', sql.VarChar(50), evaluationDateTo)
        .input('EvaluationHourFrom', sql.VarChar(50), evaluationHourFrom)
        .input('EvaluationHourTo', sql.VarChar(50), evaluationHourTo)
        .input('InteractionMinDuration', sql.Int, interactionMinDuration)
        .input('InteractionMaxDuration', sql.Int, interactionMaxDuration)
        .input('InteractionOrigins', sql.VarChar(50), interactionOrigins)
        .input('InteractionResults', sql.VarChar(sql.MAX), interactionResults)
        .input('InteractionTags', sql.VarChar(sql.MAX), interactionTags)
        .input('InteractionFormats', sql.VarChar(sql.MAX), interactionFormats)
        .input("InteractionIds", sql.VarChar(sql.MAX), interactionIds)
        .execute('GetEvaluatedInteractionsByAuditor')
        .then((sqlResult) => {
        logger.info('[InteractionMSSql::GetEvaluatedInteractionsByAuditor] Received resulto from GetEvaluatedInteractionsByAuditor SP');
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error on \'' + err.procName + '\': ' : 'Error requesting: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error('[InteractionMSSql::GetEvaluatedInteractionsByAuditor] ' + errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluatedInteractionsByAuditor = GetEvaluatedInteractionsByAuditor;
function GetEvaluatedInteractionsByCampaignsAuditorsAndAgents(instance, auditorIds, agentIds, campaignIds, evaluationDateFrom, evaluationDateTo, evaluationHourFrom, evaluationHourTo, interactionMinDuration, interactionMaxDuration, interactionOrigins, interactionResults, evaluationTypes, interactionTags, interactionFormats, contactAddress) {
    logger.info('[InteractionMSSql::GetEvaluatedInteractionsByCampaignsAuditorsAndAgents] Received Instance: ' + instance);
    logger.info('[InteractionMSSql::GetEvaluatedInteractionsByCampaignsAuditorsAndAgents] Calling SP GetEvaluatedInteractionsByCampaignsAuditorsAndAgents');
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('IdAuditor', sql.VarChar(sql.MAX), auditorIds)
        .input('IdAgent', sql.VarChar(sql.MAX), agentIds)
        .input('IdCampaign', sql.VarChar(sql.MAX), campaignIds)
        .input('EvaluationDateFrom', sql.VarChar(sql.MAX), evaluationDateFrom)
        .input('EvaluationDateTo', sql.VarChar(sql.MAX), evaluationDateTo)
        .input('EvaluationHourFrom', sql.VarChar(50), evaluationHourFrom)
        .input('EvaluationHourTo', sql.VarChar(50), evaluationHourTo)
        .input('InteractionMinDuration', sql.Int, interactionMinDuration)
        .input('InteractionMaxDuration', sql.Int, interactionMaxDuration)
        .input('InteractionOrigins', sql.VarChar(50), interactionOrigins)
        .input('InteractionResults', sql.VarChar(sql.MAX), interactionResults)
        .input('EvaluationTypes', sql.VarChar(sql.MAX), evaluationTypes)
        .input('InteractionTags', sql.VarChar(sql.MAX), interactionTags)
        .input('InteractionFormats', sql.VarChar(sql.MAX), interactionFormats)
        .input('ContactAddress', sql.VarChar(300), contactAddress)
        .execute('GetEvaluatedInteractionsByCampaignsAuditorsAndAgents')
        .then((sqlResult) => {
        logger.info('[InteractionMSSql::GetEvaluatedInteractionsByCampaignsAuditorsAndAgents] Received result from GetEvaluatedInteractionsByCampaignsAuditorsAndAgents SP');
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error on \'' + err.procName + '\': ' : 'Requesting error: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error('[InteractionMSSql::GetEvaluatedInteractionsByCampaignsAuditorsAndAgents] ' + errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluatedInteractionsByCampaignsAuditorsAndAgents = GetEvaluatedInteractionsByCampaignsAuditorsAndAgents;
function GetEvaluatedInteractions(instance, auditorIds, agentIds, campaignIds, evaluationDateFrom, evaluationDateTo, evaluationHourFrom, evaluationHourTo, interactionMinDuration, interactionMaxDuration, interactionOrigins, interactionResults, interactionTags, interactionFormats) {
    logger.info('[InteractionMSSql::GetEvaluatedInteractions] Received Instance: ' + instance);
    logger.info('[InteractionMSSql::GetEvaluatedInteractions] Calling SP GetEvaluatedInteractions');
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('IdAuditor', sql.VarChar(sql.MAX), auditorIds)
        .input('IdAgent', sql.VarChar(sql.MAX), agentIds)
        .input('IdCampaign', sql.VarChar(sql.MAX), campaignIds)
        .input('EvaluationDateFrom', sql.VarChar(50), evaluationDateFrom)
        .input('EvaluationDateTo', sql.VarChar(50), evaluationDateTo)
        .input('EvaluationHourFrom', sql.VarChar(50), evaluationHourFrom)
        .input('EvaluationHourTo', sql.VarChar(50), evaluationHourTo)
        .input('InteractionMinDuration', sql.Int, interactionMinDuration)
        .input('InteractionMaxDuration', sql.Int, interactionMaxDuration)
        .input('InteractionOrigins', sql.VarChar(50), interactionOrigins)
        .input('InteractionResults', sql.VarChar(sql.MAX), interactionResults)
        .input('InteractionTags', sql.VarChar(sql.MAX), interactionTags)
        .input('InteractionFormats', sql.VarChar(sql.MAX), interactionFormats)
        .execute('GetEvaluatedInteractions')
        .then((sqlResult) => {
        logger.info('[InteractionMSSql::GetEvaluatedInteractions] Received result from GetEvaluatedInteractions SP');
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        return Promise.resolve(recordset);
    })
        .catch((err) => {
        let errorMsg = (err && err.procName ? 'Error on \'' + err.procName + '\': ' : 'Requesting error: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error('[InteractionMSSql::GetEvaluatedInteractions] ' + errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluatedInteractions = GetEvaluatedInteractions;
function GetEvaluationTypesInteraction(vcc, interactionId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('InteractionId', sql.VarChar(250), interactionId)
        .execute('GetEvaluationTypesInteraction')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetEvaluationTypesInteraction = GetEvaluationTypesInteraction;
function GetInteractions(instance, limit, agents, campaigns, dateIni, dateFin, minDuration, maxDuration, origins, hourIni, hourFin, tags, evaluationTypes, results, formats, interactionIds = '', evaluated = '', withSectionPart) {
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('IdAgent', sql.VarChar(sql.MAX), agents)
        .input('IdCampaign', sql.VarChar(sql.MAX), campaigns)
        .input('EvaluationDateFrom', sql.VarChar(50), dateIni)
        .input('EvaluationDateTo', sql.VarChar(50), dateFin)
        .input('EvaluationHourFrom', sql.VarChar(50), hourIni)
        .input('EvaluationHourTo', sql.VarChar(50), hourFin)
        .input('InteractionMinDuration', sql.Int, minDuration)
        .input('InteractionMaxDuration', sql.Int, maxDuration)
        .input('InteractionOrigins', sql.VarChar(50), origins)
        .input('InteractionsLimit', sql.Int, limit)
        .input('InteractionTags', sql.VarChar(sql.MAX), tags)
        .input('InteractionEvaluationTypes', sql.VarChar(sql.MAX), evaluationTypes)
        .input('InteractionResults', sql.VarChar(sql.MAX), results)
        .input('InteractionFormats', sql.VarChar(50), formats)
        .input('InteractionIds', sql.VarChar(sql.MAX), interactionIds)
        .input('Evaluated', sql.VarChar(sql.MAX), evaluated)
        .input('InteractionWithSectionPart', sql.Bit, withSectionPart)
        .execute('GetInteractionsSearch')
        .then((sqlResult) => {
        let recorddata = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : "No result");
        logger.info('[InteractionMSSql::GetInteractions] Interaccions search result: ', sqlResult.recordsets);
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[1] : null);
        let result = new interaction_model_1.InteractionView;
        result.interactionType = 'CALL';
        result.totalTime = recorddata[0].totalTime;
        result.totalRecords = recorddata[0].totalRecords;
        result.interactions = recordset;
        return Promise.resolve(result);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error on \'' + err.procName + '\': ' : 'Request executing error: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error('[InteractionMSSql::GetInteractions] ' + errorMsg);
        return Promise.reject(err);
    });
}
exports.GetInteractions = GetInteractions;
function GetAllegroInteractions(ip, vcc, startDate, endDate, startHour, endHour, campaign, agent, resultCode, type, origin, minDuration, maxDuration, format, interactionIds = '', evaluated = '', resultType, contactAddress, limitIntByAgent) {
    return new sql.Request(sqlConn)
        .input('Ip', sql.VarChar(50), ip)
        .input('VCC', sql.VarChar(50), vcc)
        .input('StartDate', sql.DateTime, startDate)
        .input('EndDate', sql.DateTime, endDate)
        .input('StartHour', sql.VarChar(50), startHour)
        .input('EndHour', sql.VarChar(50), endHour)
        .input('Campaign', sql.VarChar(sql.MAX), campaign)
        .input('Agent', sql.VarChar(sql.MAX), agent)
        .input('ResultCode', sql.VarChar(sql.MAX), resultCode)
        .input('Type', sql.Int, type)
        .input('Origin', sql.VarChar(sql.MAX), origin)
        .input('MinDuration', sql.Int, minDuration)
        .input('MaxDuration', sql.Int, maxDuration)
        .input('Format', sql.VarChar(50), format)
        .input('InteractionIds', sql.VarChar(sql.MAX), interactionIds)
        .input('Evaluated', sql.VarChar(sql.MAX), evaluated)
        .input('ResultType', sql.VarChar(50), resultType)
        .input('ContactAddress', sql.VarChar(300), contactAddress)
        .input('LimitIntByAgent', sql.Int, limitIntByAgent)
        .execute('GetAllegroInteractions')
        .then((sqlResult) => {
        let summary = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : "No result");
        let detail = [];
        let filtersAgent = [];
        if (resultType === 'DETAILED') {
            detail = (sqlResult.recordsets && sqlResult.recordsets.length > 1 ? sqlResult.recordsets[1] : []);
        }
        if (resultType === 'SUMMARIZED') {
            filtersAgent = (sqlResult.recordsets && sqlResult.recordsets.length > 1 ? sqlResult.recordsets[1] : []);
        }
        let result = {};
        let recordset = (summary && summary.length > 0 ? summary[0] : null);
        result.interactionType = recordset && recordset.interactionType ? recordset.interactionType : 'CALL';
        result.totalInteractions = recordset && recordset.interactions ? recordset.interactions : 0;
        result.totalInteractionDetails = recordset && recordset.details ? recordset.details : 0;
        result.totalInteractionTime = recordset && recordset.attentionTime ? recordset.attentionTime : 0;
        result.filtersAgent = filtersAgent.map(fa => fa.agent);
        if (resultType === 'SUMMARIZED') {
        }
        else if (resultType === 'DETAILED') {
            result.interactions = detail ? detail : [];
        }
        return Promise.resolve(result);
    })
        .catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error('[InteractionMSSql::GetAllegroInteractions] ' + errorMsg);
        return Promise.reject(err);
    });
}
exports.GetAllegroInteractions = GetAllegroInteractions;
;
function GetI6CallInteractions(ip, vcc, type, interactionType, startDate, endDate, startHour, endHour, campaigns, agents, dispositionCodes, origins, minDuration, maxDuration, interactionIds = '', evaluated = '', uniqueIds, resultType, contactAddress) {
    return new sql.Request(sqlConn)
        .input('Ip', sql.VarChar(50), ip)
        .input('VCC', sql.VarChar(50), vcc)
        .input('Type', sql.Int, type)
        .input('InteractionType', sql.VarChar(50), interactionType)
        .input('StartDate', sql.DateTime, startDate)
        .input('EndDate', sql.DateTime, endDate)
        .input('StartHour', sql.VarChar(50), startHour)
        .input('EndHour', sql.VarChar(50), endHour)
        .input('Campaigns', sql.VarChar(sql.MAX), campaigns)
        .input('Agents', sql.VarChar(sql.MAX), agents)
        .input('DispositionCodes', sql.VarChar(sql.MAX), dispositionCodes)
        .input('Origins', sql.VarChar(50), origins)
        .input('MinDuration', sql.Int, minDuration)
        .input('MaxDuration', sql.Int, maxDuration)
        .input('InteractionIds', sql.VarChar(sql.MAX), interactionIds)
        .input('Evaluated', sql.VarChar(sql.MAX), evaluated)
        .input('UniqueIds', sql.Bit, uniqueIds)
        .input('ResultType', sql.VarChar(50), resultType)
        .input('ContactAddress', sql.VarChar(300), contactAddress)
        .execute('GetI6SyncInteractions')
        .then((sqlResult) => {
        let recorddata = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : []);
        let result = {};
        if (resultType === 'SUMMARIZED') {
            let recordset = (recorddata && recorddata.length > 0 ? recorddata[0] : null);
            result.interactionType = recordset && recordset.interactionType ? recordset.interactionType : interactionType;
            result.totalInteractions = recordset && recordset.interactions ? recordset.interactions : 0;
            result.totalInteractionDetails = recordset && recordset.details ? recordset.details : 0;
            result.totalInteractionTime = recordset && recordset.attentionTime ? recordset.attentionTime : 0;
        }
        else if (resultType === 'DETAILED') {
            result.interactionType = interactionType;
            result.totalInteractions = recorddata.length ?
                recorddata.map(item => item.InteractionId).filter((value, index, self) => self.indexOf(value) === index).length
                :
                    0;
            result.totalInteractionDetails = recorddata.length ? recorddata.length : 0;
            result.interactions = [];
            recorddata.map(rd => {
                if (rd.TotalParts === null || rd.TotalParts === 0)
                    rd.TotalParts = 1;
                for (let i = 1; i <= rd.TotalParts; i++) {
                    let currentItem = JSON.parse(JSON.stringify(rd));
                    currentItem.ID = currentItem.InteractionId + '_0_' + i;
                    currentItem.Part = i;
                    result.interactions.push(currentItem);
                }
            });
        }
        return Promise.resolve(result);
    })
        .catch((err) => {
        let errorMsg = (err && err.procName ? 'Error on \'' + err.procName + '\': ' : 'Request executing error: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error('[InteractionMSSql::GetI6AsyncInteractions] ' + errorMsg);
        return Promise.reject(err);
    });
}
exports.GetI6CallInteractions = GetI6CallInteractions;
function GetI6AlreadyRegisteredCallInteractions(vcc, interactions) {
    let table = SetInteractionsToTemporaryTable(vcc, interactions);
    return GetI6AlreadyRegisteredInteractionsFromTemporaryTable(table, vcc, 'Call');
}
exports.GetI6AlreadyRegisteredCallInteractions = GetI6AlreadyRegisteredCallInteractions;
function GetI6AlreadyRegisteredTextInteractions(vcc, interactions) {
    let table = SetInteractionsToTemporaryTable(vcc, interactions);
    return GetI6AlreadyRegisteredInteractionsFromTemporaryTable(table, vcc, 'Text');
}
exports.GetI6AlreadyRegisteredTextInteractions = GetI6AlreadyRegisteredTextInteractions;
function GetI6AlreadyRegisteredInteractionsFromTemporaryTable(temporaryTable, vcc, target) {
    let transaction = new sql.Transaction(sqlConn);
    let request;
    return transaction.begin()
        .then((result) => {
        logger.info('[InteractionsMSSql::GetI6AlreadyRegisteredInteractionsFromTemporaryTable] Creating transaction');
        return new sql.Request(transaction);
    })
        .then((result) => {
        request = result;
        return request.bulk(temporaryTable)
            .then((rowCount) => {
            logger.info('[InteractionsMSSql::GetI6AlreadyRegisteredInteractionsFromTemporaryTable] Inserted ' + rowCount + ' records to temporary Table');
            return Promise.resolve(true);
        })
            .catch((err) => {
            logger.error('[InteractionsMSSql::GetI6AlreadyRegisteredInteractionsFromTemporaryTable] Error on bulk: ' + err.message);
            throw err;
        });
    })
        .then(result => {
        return request
            .input('VCC', sql.VarChar(50), vcc)
            .execute(`GetI6AlreadyRegistered${target}Interactions`)
            .then((sqlResult) => {
            logger.info('[InteractionsMSSql::GetI6AlreadyRegisteredInteractionsFromTemporaryTable] Ejecucion Correcta');
            let results = sqlResult.recordsets?.length ? sqlResult.recordsets[0] : [];
            return Promise.resolve(results);
        })
            .catch((err) => {
            logger.error('[InteractionsMSSql::GetI6AlreadyRegisteredInteractionsFromTemporaryTable] Al ejecutar el procedure: ' + err.message);
            return Promise.reject(err);
        });
    })
        .then((result) => {
        logger.info('[InteractionsMSSql::GetI6AlreadyRegisteredInteractionsFromTemporaryTable] Saving transaction');
        transaction.commit();
        return Promise.resolve(result);
    })
        .catch((err) => {
        logger.error('[InteractionsMSSql::GetI6AlreadyRegisteredInteractionsFromTemporaryTable] Parsing error: ' + err.message);
        transaction.rollback();
        return Promise.reject(err);
    });
}
function GetI6TextInteractions(ip, vcc, type, interactionType, startDate, endDate, startHour, endHour, campaigns, agents, dispositionCodes, origins, interactionIds = '', evaluated = '', uniqueIds, resultType, contactAddress) {
    return new sql.Request(sqlConn)
        .input('Ip', sql.VarChar(50), ip)
        .input('VCC', sql.VarChar(50), vcc)
        .input('Type', sql.Int, type)
        .input('InteractionType', sql.VarChar(50), interactionType)
        .input('StartDate', sql.DateTime, startDate)
        .input('EndDate', sql.DateTime, endDate)
        .input('StartHour', sql.VarChar(50), startHour)
        .input('EndHour', sql.VarChar(50), endHour)
        .input('Campaigns', sql.VarChar(sql.MAX), campaigns)
        .input('Agents', sql.VarChar(sql.MAX), agents)
        .input('DispositionCodes', sql.VarChar(sql.MAX), dispositionCodes)
        .input('Origins', sql.VarChar(50), origins)
        .input("InteractionIds", sql.VarChar(sql.MAX), interactionIds)
        .input("Evaluated", sql.VarChar(sql.MAX), evaluated)
        .input('UniqueIds', sql.Bit, uniqueIds)
        .input('ResultType', sql.VarChar(50), resultType)
        .input('ContactAddress', sql.VarChar(300), contactAddress)
        .execute('GetI6AsyncInteractions')
        .then((sqlResult) => {
        let recorddata = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : "No result");
        let result = new interaction_model_1.AsyncInteractionView;
        if (resultType === 'SUMMARIZED') {
            let recordset = (recorddata && recorddata.length > 0 ? recorddata[0] : null);
            result.interactionType = recordset && recordset.interactionType ? recordset.interactionType : interactionType;
            result.totalInteractions = recordset && recordset.interactions ? recordset.interactions : 0;
            result.totalInteractionDetails = recordset && recordset.details ? recordset.details : 0;
        }
        else if (resultType === 'DETAILED') {
            result.interactionType = interactionType;
            result.totalInteractions = recorddata.length ?
                recorddata.map(item => item.id).filter((value, index, self) => self.indexOf(value) === index).length
                :
                    0;
            result.totalInteractionDetails = recorddata.length ? recorddata.length : 0;
            result.interactions = recorddata ? recorddata : [];
        }
        return Promise.resolve(result);
    })
        .catch((err) => {
        let errorMsg = (err && err.procName ? 'Error on \'' + err.procName + '\': ' : 'Request executing error: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error('[InteractionMSSql::GetI6AsyncInteractions] ' + errorMsg);
        return Promise.reject(err);
    });
}
exports.GetI6TextInteractions = GetI6TextInteractions;
function BulkBillingInteractions(vcc, modelSecondsPerRequest, modelCharsPerPhrase, channel, interactions, retranscription) {
    let table = SetInteractionsToTemporaryTable(vcc, interactions);
    return GetBillingInteractionsFromTemporaryTable(table, vcc, modelSecondsPerRequest, modelCharsPerPhrase, channel, retranscription);
}
exports.BulkBillingInteractions = BulkBillingInteractions;
function SetInteractionsToTemporaryTable(vcc, data) {
    let table = new sql.Table('#InteractionsTemp');
    table.create = true;
    table.columns.add('VCC', sql.VarChar(50), { nullable: true });
    table.columns.add('ID', sql.VarChar(250), { nullable: true });
    table.columns.add('InteractionId', sql.VarChar(250), { nullable: true });
    table.columns.add('Section', sql.Int, { nullable: true });
    table.columns.add('Part', sql.Int, { nullable: true });
    table.columns.add('Folder', sql.VarChar(25), { nullable: true });
    table.columns.add('Channel', sql.VarChar(25), { nullable: true });
    table.columns.add('Campaign', sql.VarChar(50), { nullable: true });
    table.columns.add('EndDate', sql.DateTime, { nullable: true });
    table.columns.add('AttentionTime', sql.Int, { nullable: true });
    table.columns.add('RawChar', sql.Int, { nullable: true });
    table.columns.add('Agent', sql.VarChar(50), { nullable: true });
    data.forEach(d => {
        table.rows.add(vcc, d.ID, d.InteractionId ? d.InteractionId : null, d.Section ? d.Section : 0, d.Part ? d.Part : 0, d.folder ? d.folder : null, d.InteractionType ? d.InteractionType : d.channel ? d.channel : null, d.Campaign ? d.Campaign : null, d.EndDate ? moment(d.EndDate + 'Z').toDate() : null, d.AttentionTime ? d.AttentionTime : null, d.rawChar ? d.rawChar : null, d.agent ? d.agent : d.lastTakedAgent ? d.lastTakedAgent : null);
    });
    return table;
}
function GetBillingInteractionsFromTemporaryTable(temporaryTable, vcc, secondsPerRequest, charsPerPhrase, channel, retranscription) {
    let transaction = new sql.Transaction(sqlConn);
    let request;
    return transaction.begin()
        .then((result) => {
        logger.info('[InteractionsMSSql::GetBillingInteractionsFromTemporaryTable] Creating transaction');
        return new sql.Request(transaction);
    })
        .then((result) => {
        request = result;
        return request.bulk(temporaryTable)
            .then((rowCount) => {
            logger.info('[InteractionsMSSql::GetBillingInteractionsFromTemporaryTable] Inserted ' + rowCount + ' records to temporary Table');
            return true;
        })
            .catch((err) => {
            logger.error('[InteractionsMSSql::GetBillingInteractionsFromTemporaryTable] Error on bulk: ' + err.message);
            throw err;
        });
    })
        .then(result => {
        return request
            .input('VCC', sql.VarChar(50), vcc)
            .input('SecondsPerRequest', sql.Decimal(18, 5), secondsPerRequest)
            .input('CharsPerPhrase', sql.Decimal(18, 5), charsPerPhrase)
            .input('Channel', sql.VarChar(25), channel)
            .input('Retranscription', sql.Int, retranscription)
            .execute('GetBillingInteractions')
            .then((sqlResult) => {
            logger.info('[InteractionsMSSql::GetBillingInteractionsFromTemporaryTable] Ejecucion Correcta');
            let results = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
            let promiseArray = [];
            promiseArray.push(Promise.resolve(results && results.length > 0 ? results[0] : null));
            promiseArray.push(transaction.commit());
            return Promise.all(promiseArray);
        })
            .catch((err) => {
            logger.error('[InteractionsMSSql::GetBillingInteractionsFromTemporaryTable] Al ejecutar el procedure: ' + err.message);
            return Promise.reject(err);
        });
    })
        .then((result) => {
        logger.info('[InteractionsMSSql::GetBillingInteractionsFromTemporaryTable] Saving transaction');
        return Promise.resolve(result[0]);
    })
        .catch((err) => {
        logger.error('[InteractionsMSSql::GetBillingInteractionsFromTemporaryTable] Parsing error: ' + err.message);
        transaction.rollback();
        return Promise.reject(err);
    });
}
function GetAsyncBillingInteractions(ip, vcc, type, interactionType, startDate, endDate, startHour, endHour, campaigns, agents, dispositionCodes, origins, interactionIds = '', cognitiveServiceCharsPerPhrase) {
    return new sql.Request(sqlConn)
        .input('Ip', sql.VarChar(50), ip)
        .input('VCC', sql.VarChar(50), vcc)
        .input('Type', sql.Int, type)
        .input('InteractionType', sql.VarChar(50), interactionType)
        .input('StartDate', sql.DateTime, startDate)
        .input('EndDate', sql.DateTime, endDate)
        .input('StartHour', sql.VarChar(50), startHour)
        .input('EndHour', sql.VarChar(50), endHour)
        .input('Campaigns', sql.VarChar(sql.MAX), campaigns)
        .input('Agents', sql.VarChar(sql.MAX), agents)
        .input('DispositionCodes', sql.VarChar(sql.MAX), dispositionCodes)
        .input('Origins', sql.VarChar(50), origins)
        .input("InteractionIds", sql.VarChar(sql.MAX), interactionIds)
        .input('CharsPerPhrase', sql.Int, cognitiveServiceCharsPerPhrase)
        .execute('GetAsyncBillingInteractions')
        .then((sqlResult) => {
        let recorddata = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : "No result");
        let recordset = (recorddata && recorddata.length > 0 ? recorddata[0] : null);
        return Promise.resolve(recordset);
    })
        .catch((err) => {
        let errorMsg = (err && err.procName ? 'Error on \'' + err.procName + '\': ' : 'Request executing error: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error('[InteractionMSSql::GetAsyncBillingInteractions] ' + errorMsg);
        return Promise.reject(err);
    });
}
exports.GetAsyncBillingInteractions = GetAsyncBillingInteractions;
function GetInteractionTranscription(vcc, evaluationPlanId, processId, interactionType, interactionId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('EvaluationPlanId', sql.VarChar(50), evaluationPlanId)
        .input('ProcessId', sql.VarChar(50), processId)
        .input('InteractionType', sql.VarChar(250), interactionType)
        .input('InteractionId', sql.VarChar(250), interactionId)
        .execute('GetInteractionTranscription')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetInteractionTranscription = GetInteractionTranscription;
function GetInteractionQueryResults(vcc, transactionType, transactionId, interactionType, interactionId, campaign, folder) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('TransactionType', sql.VarChar(50), transactionType)
        .input('TransactionId', sql.VarChar(50), transactionId)
        .input('InteractionType', sql.VarChar(10), interactionType)
        .input('InteractionId', sql.VarChar(250), interactionId)
        .input('Campaign', sql.VarChar(100), campaign)
        .input('Folder', sql.VarChar(50), folder)
        .execute('GetInteractionQueryResults')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        recordset.map(r => {
            if (r.queryData) {
                r.queryData = JSON.parse(r.queryData);
                r.details = JSON.parse(r.details);
            }
        });
        return Promise.resolve(recordset);
    })
        .catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetInteractionQueryResults = GetInteractionQueryResults;
function GetI6InteractionAudios(vcc, interactionId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('InteractionId', sql.VarChar(250), interactionId)
        .execute('GetI6InteractionAudios')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        return Promise.resolve(recordset);
    })
        .catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetI6InteractionAudios = GetI6InteractionAudios;
function GetI6InteractionMessages(vcc, interactionId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('InteractionId', sql.VarChar(250), interactionId)
        .execute('GetI6InteractionMessages')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        return Promise.resolve(recordset);
    })
        .catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetI6InteractionMessages = GetI6InteractionMessages;
function SaveI6InteractionAudio(vcc, interactionId, oldSection, oldPart, newSection, newPart, startDate = null, endDate = null, durationTime = null, agentId, format, campaign, origin, category1, category2, category3, description, filename = null, contactId, contactName, contactAddress, processId = null, ender = null, ticket = null) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('InteractionId', sql.VarChar(250), interactionId)
        .input('OldSection', sql.Int, oldSection)
        .input('OldPart', sql.Int, oldPart)
        .input('NewSection', sql.Int, newSection)
        .input('NewPart', sql.Int, newPart)
        .input('StartDate', sql.DateTime(), startDate)
        .input('EndDate', sql.DateTime(), endDate)
        .input('DurationTime', sql.Int, durationTime)
        .input('AgentId', sql.VarChar(50), agentId)
        .input('Format', sql.VarChar(50), format)
        .input('Campaign', sql.VarChar(100), campaign)
        .input('Origin', sql.VarChar(25), origin)
        .input('Category1', sql.VarChar(100), category1)
        .input('Category2', sql.VarChar(100), category2)
        .input('Category3', sql.VarChar(100), category3)
        .input('Description', sql.VarChar(100), description)
        .input('Filename', sql.VarChar(200), filename)
        .input('ContactId', sql.VarChar(50), contactId)
        .input('ContactName', sql.VarChar(300), contactName)
        .input('ContactAddress', sql.VarChar(300), contactAddress)
        .input('ProcessId', sql.VarChar(50), processId)
        .input('Ender', sql.VarChar(300), ender)
        .input('Ticket', sql.VarChar(250), ticket)
        .execute('SaveI6InteractionAudio')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    })
        .catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.SaveI6InteractionAudio = SaveI6InteractionAudio;
function DeleteI6InteractionAudio(vcc, interactionId, section, part) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('InteractionId', sql.VarChar(250), interactionId)
        .input('Section', sql.Int, section)
        .input('Part', sql.Int, part)
        .execute('DeleteI6InteractionAudio')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    })
        .catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.DeleteI6InteractionAudio = DeleteI6InteractionAudio;
function CloseI6InteractionAudio(vcc = null, interactionId = null, succed, errorMessage) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('InteractionId', sql.VarChar(250), interactionId)
        .input('Succed', sql.Bit, succed)
        .input('ErrorMessage', sql.VarChar(50), errorMessage)
        .execute('CloseI6InteractionAudio')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    })
        .catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.CloseI6InteractionAudio = CloseI6InteractionAudio;
function SaveI6InteractionAsyncInteraction(vcc = null, interactionId = null, channel = null, folder = null, startDate = null, endDate = null, durationTime = null, agentId = null, campaign = null, account = null, origin = null, dispositionTreePath = null, dispositionCode = null, exportedContent = null, contactId = null, contactName = null, contactAddress = null, totalMessages = null, processId = null, ender = null, ticket = null) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('InteractionId', sql.VarChar(250), interactionId)
        .input('Folder', sql.VarChar(50), folder)
        .input('Channel', sql.VarChar(25), channel)
        .input('StartDate', sql.DateTime(), startDate)
        .input('EndDate', sql.DateTime(), endDate)
        .input('DurationTime', sql.Int, durationTime)
        .input('AgentId', sql.VarChar(50), agentId)
        .input('Campaign', sql.VarChar(100), campaign)
        .input('Account', sql.VarChar(50), account)
        .input('Origin', sql.VarChar(25), origin)
        .input('DispositionTreePath', sql.VarChar(100), dispositionTreePath)
        .input('DispositionCode', sql.VarChar(100), dispositionCode)
        .input('ExportedContent', sql.VarChar(250), exportedContent)
        .input('ContactId', sql.VarChar(50), contactId)
        .input('ContactName', sql.VarChar(300), contactName)
        .input('ContactAddress', sql.VarChar(300), contactAddress)
        .input('TotalMessages', sql.Int, totalMessages)
        .input('ProcessId', sql.VarChar(50), processId)
        .input('Ender', sql.VarChar(300), ender)
        .input('Ticket', sql.VarChar(300), ticket)
        .execute('SaveI6InteractionAsyncInteraction')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    })
        .catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.SaveI6InteractionAsyncInteraction = SaveI6InteractionAsyncInteraction;
function DeleteI6InteractionText(vcc = null, interactionId = null, folder = null) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('InteractionId', sql.VarChar(250), interactionId)
        .input('Folder', sql.Int, folder)
        .execute('DeleteI6InteractionText')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    })
        .catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.DeleteI6InteractionText = DeleteI6InteractionText;
function CloseI6InteractionAsyncInteraction(vcc = null, interactionId = null, folder, channel, succed, errorMessage) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('InteractionId', sql.VarChar(250), interactionId)
        .input('Folder', sql.VarChar(50), folder)
        .input('Channel', sql.VarChar(25), channel)
        .input('Succed', sql.Bit, succed)
        .input('ErrorMessage', sql.VarChar(50), errorMessage)
        .execute('CloseI6InteractionAsyncInteraction')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    })
        .catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.CloseI6InteractionAsyncInteraction = CloseI6InteractionAsyncInteraction;
