"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.GetProfileImage = exports.ProfileImageMSSql = void 0;
const log4js = require("log4js");
let sql = require('mssql');
let logger = log4js.getLogger('Sql');
let sqlConn;
function ProfileImageMSSql(app) {
    sqlConn = app.get('sqlConn');
}
exports.ProfileImageMSSql = ProfileImageMSSql;
function GetProfileImage(instance, type, id) {
    return new sql.Request(sqlConn)
        .input('Instance', sql.VarChar(50), instance)
        .input('Type', sql.VarChar(50), type)
        .input('ID', sql.VarChar(50), id)
        .execute('GetProfileImage')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let profileImage = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(profileImage);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetProfileImage = GetProfileImage;
