"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SaveRealtimeEvaluationPlan = exports.GetCurrentRealtimeEvaluationPlan = exports.RealtimeEvaluationPlanMSSql = void 0;
const log4js = require("log4js");
let sql = require('mssql');
let logger = log4js.getLogger('Sql');
let sqlConn;
function RealtimeEvaluationPlanMSSql(app) {
    sqlConn = app.get('sqlConn');
}
exports.RealtimeEvaluationPlanMSSql = RealtimeEvaluationPlanMSSql;
function GetCurrentRealtimeEvaluationPlan(vcc, evaluationFormatId, campaignId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('EvaluationFormatId', sql.VarChar(50), evaluationFormatId)
        .input('CampaignId', sql.VarChar(100), campaignId)
        .input('IsActive', sql.Bit, true)
        .execute('GetRealtimeEvaluationPlans')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let item = (recordset?.length > 0 ? recordset[0] : null);
        return Promise.resolve(item);
    })
        .catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetCurrentRealtimeEvaluationPlan = GetCurrentRealtimeEvaluationPlan;
function SaveRealtimeEvaluationPlan(vcc, id, campaignId, description, modality, evaluationFormatId, enabled, statusDescription, status, evaluationMode, currentUser) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('ID', sql.VarChar(50), id)
        .input('CampaignId', sql.VarChar(50), campaignId)
        .input('Description', sql.VarChar(200), description)
        .input('Modality', sql.VarChar(50), modality)
        .input('EvaluationFormatId', sql.VarChar(50), evaluationFormatId)
        .input('Enabled', sql.Bit(), enabled)
        .input('StatusDescription', sql.VarChar(50), statusDescription)
        .input('Status', sql.Numeric(2), status)
        .input('EvaluationMode', sql.VarChar(10), evaluationMode)
        .input('CurrentUser', sql.VarChar(50), currentUser)
        .execute('SaveRealtimeEvaluationPlan')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        logger.info('[RealtimeEvaluationPlanMSSql::SaveRealtimeEvaluationPlan] Success request');
        let output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output?.result === 1);
    })
        .catch((err) => {
        let errorMsg = (err && err.procName ? 'Error \'' + err.procName + '\': ' : 'Error on request: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error('[RealtimeEvaluationPlanMSSql::SaveRealtimeEvaluationPlan] ' + errorMsg);
        return Promise.reject(err);
    });
}
exports.SaveRealtimeEvaluationPlan = SaveRealtimeEvaluationPlan;
