"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BulkTemplateThemeItem = exports.BulkTemplateThemeItemTemp = exports.BulkTemplateTheme = exports.BulkTemplateThemeTemp = exports.DeleteTemplateTheme = exports.DeleteTemplate = exports.SaveTemplateThemeItem = exports.SaveTemplateTheme = exports.SaveTemplate = exports.SaveTemplateThemeItemEntity = exports.GetTemplateThemeItemEntities = exports.GetTemplateThemeItemById = exports.GetTemplateThemeModels = exports.GetTemplateThemeItems = exports.GetTemplateThemes = exports.GetTemplateByName = exports.GetTemplate = exports.GetTemplatesVCC = exports.GetTemplates = exports.TemplateMSSql = void 0;
const log4js = require("log4js");
let sql = require('mssql');
let logger = log4js.getLogger('Sql');
let sqlConn;
function TemplateMSSql(app) {
    sqlConn = app.get('sqlConn');
}
exports.TemplateMSSql = TemplateMSSql;
function GetTemplates(vcc, type, search_criteria, search_expression, language = 'en') {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('Type', sql.VarChar(50), type)
        .input('SearchCriteria', sql.VarChar(50), search_criteria)
        .input('SearchExpression', sql.VarChar(50), search_expression)
        .input('Language', sql.VarChar(5), language)
        .execute('GetTemplates')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetTemplates = GetTemplates;
function GetTemplatesVCC(vcc) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .execute('GetTemplatesVCC')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetTemplatesVCC = GetTemplatesVCC;
function GetTemplate(vcc, name) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('Name', sql.VarChar(50), name)
        .execute('GetTemplate')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let template = (recordset && recordset.length > 0 ? recordset[0] : null);
        if (template) {
            recordset = (sqlResult.recordsets && sqlResult.recordsets.length > 1 ? sqlResult.recordsets[1] : null);
            template.templateThemes = (recordset ? recordset : null);
        }
        return Promise.resolve(template);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetTemplate = GetTemplate;
function GetTemplateByName(vcc, type, name) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('Type', sql.VarChar(50), type)
        .input('Name', sql.VarChar(50), name)
        .execute('GetTemplateByName')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let template = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(template);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetTemplateByName = GetTemplateByName;
function GetTemplateThemes(vcc, templateId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('TemplateId', sql.VarChar(50), templateId)
        .execute('GetTemplateThemes')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetTemplateThemes = GetTemplateThemes;
function GetTemplateThemeItems(vcc, templateId, templateThemeId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('TemplateId', sql.VarChar(50), templateId)
        .input('TemplateThemeId', sql.VarChar(50), templateThemeId)
        .execute('GetTemplateThemeItems')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetTemplateThemeItems = GetTemplateThemeItems;
function GetTemplateThemeModels(vcc, templateId, templateThemeId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('TemplateId', sql.VarChar(50), templateId)
        .input('TemplateThemeId', sql.VarChar(50), templateThemeId)
        .execute('GetTemplateThemeModels')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetTemplateThemeModels = GetTemplateThemeModels;
function GetTemplateThemeItemById(vcc, id) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('ID', sql.VarChar(50), id)
        .execute('GetTemplateThemeItemById')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        return Promise.resolve(recordset);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetTemplateThemeItemById = GetTemplateThemeItemById;
function GetTemplateThemeItemEntities(vcc, abilityQueryId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('TemplateThemeItemId', sql.VarChar(50), abilityQueryId)
        .execute('GetTemplateThemeItemEntities')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        return Promise.resolve(recordset);
    })
        .catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.GetTemplateThemeItemEntities = GetTemplateThemeItemEntities;
function SaveTemplateThemeItemEntity(vcc, templateId, templateThemeId, templateThemeItemId, entityId, entityName, acceptancePercentage, order, createdByUserId, lastModifiedByUserId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('TemplateId', sql.VarChar(50), templateId)
        .input('TemplateThemeId', sql.VarChar(50), templateThemeId)
        .input('TemplateThemeItemId', sql.VarChar(50), templateThemeItemId)
        .input('EntityId', sql.VarChar(50), entityId)
        .input('EntityName', sql.VarChar(50), entityName)
        .input('AcceptancePercentage', sql.Decimal(18, 2), acceptancePercentage)
        .input('Order', sql.Int, order)
        .input('CreatedByUserId', sql.VarChar(50), createdByUserId)
        .input('LastModifiedByUserId', sql.VarChar(50), lastModifiedByUserId)
        .execute('SaveTemplateThemeItemEntity')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    })
        .catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.SaveTemplateThemeItemEntity = SaveTemplateThemeItemEntity;
function SaveTemplate(vcc, name, type, description, template, category, createdDate, createdByUserId, lastModifiedDate, lastModifiedByUserId) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('Name', sql.VarChar(50), name)
        .input('Type', sql.VarChar(50), type)
        .input('Description', sql.VarChar(50), description)
        .input('Template', sql.VarChar(50), template)
        .input('Category', sql.VarChar(50), category)
        .input('CreatedDate', sql.DateTime, createdDate)
        .input('CreatedByUserId', sql.VarChar(50), createdByUserId)
        .input('LastModifiedDate', sql.DateTime, lastModifiedDate)
        .input('LastModifiedByUserId', sql.VarChar(50), lastModifiedByUserId)
        .execute('SaveTemplate')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.SaveTemplate = SaveTemplate;
function SaveTemplateTheme(vcc, templateId, id, order, description, category1, category2, createdDate, createdByUserId, lastModifiedDate, lastModifiedByUserId, analysisType = 'SEMANTIC', isNegative = false) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('TemplateId', sql.VarChar(50), templateId)
        .input('ID', sql.VarChar(200), id)
        .input('Order', sql.Int, order)
        .input('Description', sql.VarChar(50), description)
        .input('Category1', sql.VarChar(50), category1)
        .input('Category2', sql.VarChar(50), category2)
        .input('CreatedDate', sql.DateTime, createdDate)
        .input('CreatedByUserId', sql.VarChar(50), createdByUserId)
        .input('LastModifiedDate', sql.DateTime, lastModifiedDate)
        .input('LastModifiedByUserId', sql.VarChar(50), lastModifiedByUserId)
        .input('AnalysisType', sql.VarChar(15), analysisType)
        .input('IsNegative', sql.Bit, isNegative)
        .execute('SaveTemplateTheme')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.SaveTemplateTheme = SaveTemplateTheme;
function SaveTemplateThemeItem(vcc, templateId, templateThemeId, id, createdDate, createdByUserId, lastModifiedDate, lastModifiedByUserId, acceptancePercentage = 0) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('TemplateId', sql.VarChar(50), templateId)
        .input('TemplateThemeId', sql.VarChar(200), templateThemeId)
        .input('ID', sql.VarChar(50), id)
        .input('CreatedDate', sql.DateTime, createdDate)
        .input('CreatedByUserId', sql.VarChar(50), createdByUserId)
        .input('LastModifiedDate', sql.DateTime, lastModifiedDate)
        .input('LastModifiedByUserId', sql.VarChar(50), lastModifiedByUserId)
        .input('AcceptancePercentage', sql.Decimal(5, 2), acceptancePercentage)
        .execute('SaveTemplateThemeItem')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.SaveTemplateThemeItem = SaveTemplateThemeItem;
function DeleteTemplate(vcc, name, type) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('Name', sql.VarChar(50), name)
        .execute('DeleteTemplate')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.DeleteTemplate = DeleteTemplate;
function DeleteTemplateTheme(vcc, name, type) {
    return new sql.Request(sqlConn)
        .input('VCC', sql.VarChar(50), vcc)
        .input('Name', sql.VarChar(200), name)
        .execute('DeleteTemplateTheme')
        .then((sqlResult) => {
        let recordset = (sqlResult.recordsets?.length ? sqlResult.recordsets[0] : null);
        let output = (recordset && recordset.length > 0 ? recordset[0] : null);
        return Promise.resolve(output && output.result === 1);
    }).catch((err) => {
        let errorMsg = (err && err.procName ? 'Error al ejecutar \'' + err.procName + '\': ' : 'Error al ejecutar consulta: ') + (err ? typeof err === 'string' ? err : err.message || err.description || '' : '');
        logger.error(errorMsg);
        return Promise.reject(err);
    });
}
exports.DeleteTemplateTheme = DeleteTemplateTheme;
function TransactionBulkTemplateTheme(table, methodValidator, nameTable) {
    let transaction = new sql.Transaction(sqlConn);
    let request;
    return transaction.begin()
        .then((result) => {
        logger.info('TransactionBulkTemplateTheme: Creando solicitud');
        return new sql.Request(transaction);
    })
        .then((result) => {
        request = result;
        return request.bulk(table)
            .then((rowCount) => {
            logger.info('TransactionBulkTemplateTheme: Bulk se insertaron : ' + rowCount + ' en la tabla temporal ' + nameTable);
            return true;
        })
            .catch((err) => {
            logger.error('TransactionBulkTemplateTheme: Al realizar el bulk: ' + err.message + ' en la tabla temporal ' + nameTable);
            throw err;
        });
    })
        .then((rowCount) => {
        logger.info('TransactionBulkTemplateTheme: Paso de la data de la tabla temporal a la tabla final');
        return methodValidator(request);
    })
        .then((result) => {
        logger.info('TransactionBulkTemplateTheme: Guardando la transaccion');
        return transaction.commit();
    })
        .then((result) => {
        return Promise.resolve(true);
    })
        .catch((err) => {
        transaction.rollback();
        logger.error('TransactionBulkTemplateTheme: Error al realizar el parseo: ' + err.message);
        return Promise.reject(err);
    });
}
function BulkTemplateThemeTemp(vcc, customTemplate, customTemplateId, data) {
    let table = new sql.Table('#TemplateThemeTemp');
    table.create = true;
    table.columns.add('VCC', sql.VarChar(50), { nullable: true });
    table.columns.add('TemplateId', sql.VarChar(50), { nullable: true });
    table.columns.add('ID', sql.VarChar(50), { nullable: true });
    table.columns.add('Order', sql.Int, { nullable: true });
    table.columns.add('Description', sql.VarChar(50), { nullable: true });
    table.columns.add('Category1', sql.VarChar(50), { nullable: true });
    table.columns.add('Category2', sql.VarChar(50), { nullable: true });
    table.columns.add('AnalysisType', sql.VarChar(50), { nullable: true });
    table.columns.add('CreatedDate', sql.DateTime, { nullable: true });
    table.columns.add('CreatedByUserId', sql.VarChar(50), { nullable: true });
    table.columns.add('LastModifiedDate', sql.DateTime, { nullable: true });
    table.columns.add('LastModifiedByUserId', sql.VarChar(50), { nullable: true });
    for (let row of data) {
        table.rows.add(vcc, customTemplateId, row.id, row.order, row.description, row.category1, row.category2, row.analysisType, customTemplate.createdDate, customTemplate.createdByUserId, customTemplate.lastModifiedDate, customTemplate.lastModifiedByUserId);
    }
    logger.info('BulkTemplateThemeTemp: Parseo Correcto');
    return TransactionBulkTemplateTheme(table, BulkTemplateTheme, '#TemplateThemeTemp');
}
exports.BulkTemplateThemeTemp = BulkTemplateThemeTemp;
function BulkTemplateTheme(request) {
    return request.execute('BulkTemplateTheme')
        .then((recordset) => {
        logger.info('BulkTemplateTheme: Ejecucion Correcta BulkTemplateTheme');
        return Promise.resolve(true);
    })
        .catch((err) => {
        logger.error('BulkTemplateTheme: Al ejecutar el procedure BulkTemplateTheme : ' + err.message);
        return Promise.reject(err);
    });
}
exports.BulkTemplateTheme = BulkTemplateTheme;
function TransactionBulkTemplateThemeItem(table, methodValidator, nameTable) {
    let transaction = new sql.Transaction(sqlConn);
    let request;
    return transaction.begin()
        .then((result) => {
        logger.info('TransactionBulkTemplateThemeItem: Creando solicitud');
        return new sql.Request(transaction);
    })
        .then((result) => {
        request = result;
        return request.bulk(table)
            .then((rowCount) => {
            logger.info('TransactionBulkTemplateThemeItem: Bulk se insertaron : ' + rowCount + ' en la tabla temporal ' + nameTable);
            return true;
        })
            .catch((err) => {
            logger.error('TransactionBulkTemplateThemeItem: Al realizar el bulk: ' + err.message + ' en la tabla temporal ' + nameTable);
            throw err;
        });
    })
        .then((rowCount) => {
        logger.info('TransactionBulkTemplateThemeItem: Paso de la data de la tabla temporal a la tabla final');
        return methodValidator(request);
    })
        .then((result) => {
        logger.info('TransactionBulkTemplateThemeItem: Guardando la transaccion');
        return transaction.commit();
    })
        .then((result) => {
        return Promise.resolve(true);
    })
        .catch((err) => {
        transaction.rollback();
        logger.error('TransactionBulkTemplateThemeItem: Error al realizar el parseo: ' + err.message);
        return Promise.reject(err);
    });
}
function BulkTemplateThemeItemTemp(vcc, customTemplate, customTemplateId, data) {
    let table = new sql.Table('#TemplateThemeItemTemp');
    table.create = true;
    table.columns.add('VCC', sql.VarChar(50), { nullable: true });
    table.columns.add('TemplateId', sql.VarChar(50), { nullable: true });
    table.columns.add('TemplateThemeId', sql.VarChar(50), { nullable: true });
    table.columns.add('ID', sql.VarChar(50), { nullable: true });
    table.columns.add('CreatedDate', sql.DateTime, { nullable: true });
    table.columns.add('CreatedByUserId', sql.VarChar(50), { nullable: true });
    table.columns.add('LastModifiedDate', sql.DateTime, { nullable: true });
    table.columns.add('LastModifiedByUserId', sql.VarChar(50), { nullable: true });
    for (let row of data) {
        table.rows.add(vcc, customTemplateId, row.templateThemeId, row.id, customTemplate.createdDate, customTemplate.createdByUserId, customTemplate.lastModifiedDate, customTemplate.lastModifiedByUserId);
    }
    logger.info('BulkTemplateThemeItemTemp: Parseo Correcto');
    return TransactionBulkTemplateThemeItem(table, BulkTemplateThemeItem, '#TemplateThemeItemTemp');
}
exports.BulkTemplateThemeItemTemp = BulkTemplateThemeItemTemp;
function BulkTemplateThemeItem(request) {
    return request.execute('BulkTemplateThemeItem')
        .then((recordset) => {
        logger.info('BulkTemplateThemeItem: Ejecucion Correcta BulkTemplateThemeItem');
        return Promise.resolve(true);
    })
        .catch((err) => {
        logger.error('BulkTemplateThemeItem: Al ejecutar el procedure BulkTemplateThemeItem : ' + err.message);
        return Promise.reject(err);
    });
}
exports.BulkTemplateThemeItem = BulkTemplateThemeItem;
