"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SendIOEvents = void 0;
const server_config_1 = require("../config/server.config");
const log4js = require("log4js");
const promises_shared_1 = require("../shared/promises.shared");
const request_shared_1 = require("../shared/request.shared");
let logger = log4js.getLogger('IO');
const fs = require('fs');
function SendIOEvents(events) {
    return promises_shared_1.DummyPromise().then(_ => {
        return request_shared_1.SimplePostRequest({
            uri: `https://localhost/io/send-events`,
            body: JSON.stringify(events),
            headers: { 'Content-Type': 'application/json' },
            httpAgent: {
                key: fs.readFileSync(server_config_1.HTTPS_KEY),
                cert: fs.readFileSync(server_config_1.HTTPS_CERT),
                rejectUnauthorized: false,
                keepAlive: true
            },
            httpsAgent: {
                key: fs.readFileSync(server_config_1.HTTPS_KEY),
                cert: fs.readFileSync(server_config_1.HTTPS_CERT),
                rejectUnauthorized: false,
                keepAlive: true
            },
            timeout: 15000,
            retryProtocol: false
        });
    }).then(result => {
        return result.data && result.data.status;
    }).catch(err => {
        logger.error("[io.requests::SendIOEvents] Error:", err);
        return false;
    });
}
exports.SendIOEvents = SendIOEvents;
