"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BatchFinished = exports.PreBatchSummary = exports.BatchManage = exports.BatchError = exports.BatchDetail = exports.Batch = void 0;
class Batch {
    constructor(installationId = null, vcc = null, batchTypeName = null, batchTypeId = null) {
        this.installationId = installationId;
        this.vcc = vcc;
        this.batchTypeName = batchTypeName;
        this.batchTypeId = batchTypeId;
    }
}
exports.Batch = Batch;
class BatchDetail {
    constructor(vcc = null, batchTypeName = null, batchTypeId = null, description = null, percentage = null, status = null, statusDescription = null) {
        this.vcc = vcc;
        this.batchTypeName = batchTypeName;
        this.batchTypeId = batchTypeId;
        this.description = description;
        this.percentage = percentage;
        this.status = status;
        this.statusDescription = statusDescription;
    }
}
exports.BatchDetail = BatchDetail;
class BatchError {
    constructor() {
        this.vcc = null;
        this.batchType = null;
        this.batchTypeId = null;
        this.batchTypeName = null;
        this.implementation = null;
        this.interactionId = null;
        this.query = null;
        this.errorFunction = null;
        this.errorMessage = null;
        this.errorDetail = null;
    }
    SetErrorData(errorFunction, errorMessage, errorDetail) {
        if (!this.errorFunction)
            this.errorFunction = errorFunction;
        if (!this.errorMessage)
            this.errorMessage = errorMessage;
        if (!this.errorDetail)
            this.errorDetail = typeof errorDetail === 'string' ? errorDetail : JSON.stringify(errorDetail);
    }
    CleanErrorData() {
        this.errorFunction = null;
        this.errorMessage = null;
        this.errorDetail = null;
    }
}
exports.BatchError = BatchError;
class BatchManage {
    constructor(vcc = null, batchTypeName = null, batchTypeId = null, systemService = null, status = null, statusDescription = null, user = null, comment = null) {
        this.vcc = vcc;
        this.batchTypeName = batchTypeName;
        this.batchTypeId = batchTypeId;
        this.systemService = systemService;
        this.status = status;
        this.statusDescription = statusDescription;
        this.user = user;
        this.comment = comment;
    }
}
exports.BatchManage = BatchManage;
class PreBatchSummary {
    constructor(installationId = null, vcc = null, totalAudio = 0, durationTime = 0, roundedTime = 0, inProcessAudio = 0, inProcessDurationTime = 0, alreadyTranscribedAudio = 0, alreadyDurationTime = 0, alreadyRoundedDurationTime = 0, alreadyTranscribedDurationTime = 0, alreadyTranscribedRoundedDurationTime = 0, totalQueries = 0, totalCognitiveModels = 0, totalGenerativeModels = 0, cognitiveModelRequests = 0, generativeModelRequests = 0, batchTypeName = null, batchTypeId = null, processId = null, templateId = null, userApi = null, startDate) {
        this.installationId = installationId;
        this.vcc = vcc;
        this.totalAudio = totalAudio;
        this.durationTime = durationTime;
        this.roundedTime = roundedTime;
        this.inProcessAudio = inProcessAudio;
        this.inProcessDurationTime = inProcessDurationTime;
        this.alreadyTranscribedAudio = alreadyTranscribedAudio;
        this.alreadyDurationTime = alreadyDurationTime;
        this.alreadyRoundedDurationTime = alreadyRoundedDurationTime;
        this.alreadyTranscribedDurationTime = alreadyTranscribedDurationTime;
        this.alreadyTranscribedRoundedDurationTime = alreadyTranscribedRoundedDurationTime;
        this.totalQueries = totalQueries;
        this.totalCognitiveModels = totalCognitiveModels;
        this.totalGenerativeModels = totalGenerativeModels;
        this.cognitiveModelRequests = cognitiveModelRequests;
        this.generativeModelRequests = generativeModelRequests;
        this.batchTypeName = batchTypeName;
        this.batchTypeId = batchTypeId;
        this.processId = processId;
        this.templateId = templateId;
        this.userApi = userApi;
        this.startDate = startDate;
        this.totalInteraction = 0;
        this.totalSync = 0;
        this.totalAsync = 0;
        this.totalAsyncDetail = 0;
        this.totalCallPhrases = 0;
        this.alreadyCallPhrases = 0;
        this.totalTextPhrases = 0;
        this.alreadyTextPhrases = 0;
        this.batchScheduleId = null;
    }
}
exports.PreBatchSummary = PreBatchSummary;
class BatchFinished {
    constructor(vcc = null, batchTypeName = null, batchTypeId = null, closedDate) {
        this.vcc = vcc;
        this.batchTypeName = batchTypeName;
        this.batchTypeId = batchTypeId;
        this.closedDate = closedDate;
        this.batchId = null;
    }
}
exports.BatchFinished = BatchFinished;
