"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BillingMovement = exports.BillingVCCRates = void 0;
class BillingVCCRates {
    constructor() {
        this.cognitiveAnalysisAverageRequestPerMinute = 0;
        this.cognitiveAnalysisAverageSecondsPerRequest = 0;
        this.cognitiveAnalysisCallBillingSecureRate = 0;
        this.cognitiveAnalysisTextBillingSecureRate = 0;
        this.generativeAnalysisAverageRequestPerMinute = 0;
        this.generativeAnalysisAverageSecondsPerRequest = 0;
        this.generativeAnalysisCallBillingSecureRate = 0;
        this.generativeAnalysisTextBillingSecureRate = 0;
        this.semanticAnalysisRatePerTransaction = 0;
        this.processCallPhrases = 0;
        this.processRoundedValidDurationTime = 0;
        this.processTextPhrases = 0;
        this.processTotalValidDurationTime = 0;
        this.cognitiveAnalysisRatePerTransaction = 0;
        this.generativeAnalysisRatePerTransaction = 0;
        this.transcriptionRatePerHour = 0;
        this.transcriptionRatePerSecond = 0;
        this.totalCost = 0.00001;
    }
    SetBillingVCCRates(object) {
        this.cognitiveAnalysisAverageRequestPerMinute = object.cognitiveAnalysisAverageRequestPerMinute;
        this.cognitiveAnalysisAverageSecondsPerRequest = object.cognitiveAnalysisAverageSecondsPerRequest;
        this.cognitiveAnalysisCallBillingSecureRate = object.cognitiveAnalysisBillingSecureRate;
        this.generativeAnalysisAverageRequestPerMinute = object.generativeAnalysisAverageRequestPerMinute;
        this.generativeAnalysisAverageSecondsPerRequest = object.generativeAnalysisAverageSecondsPerRequest;
        this.generativeAnalysisCallBillingSecureRate = object.generativeAnalysisBillingSecureRate;
        this.semanticAnalysisRatePerTransaction = object.semanticAnalysisRatePerTransaction;
        this.cognitiveAnalysisTextBillingSecureRate = object.cognitiveAnalysisTextBillingSecureRate;
        this.generativeAnalysisTextBillingSecureRate = object.generativeAnalysisTextBillingSecureRate;
        this.processCallPhrases = object.processCallPhrases;
        this.processRoundedValidDurationTime = object.processRoundedValidDurationTime;
        this.processTextPhrases = object.processTextPhrases;
        this.processTotalValidDurationTime = object.processTotalValidDurationTime;
        this.cognitiveAnalysisRatePerTransaction = object.cognitiveAnalysisRatePerTransaction;
        this.generativeAnalysisRatePerTransaction = object.generativeAnalysisRatePerTransaction;
        this.transcriptionRatePerHour = object.transcriptionRatePerHour;
        this.transcriptionRatePerSecond = object.transcriptionRatePerSecond;
    }
    GetModelAnalysisTotalAveragePhrasesFromProcess(analysisType) {
        let modelAnalysisCallBillingSecureRate = 0;
        let modelAnalysisTextBillingSecureRate = 0;
        switch (analysisType) {
            case 'COGNITIVE':
                modelAnalysisCallBillingSecureRate = this.cognitiveAnalysisCallBillingSecureRate;
                modelAnalysisTextBillingSecureRate = this.cognitiveAnalysisTextBillingSecureRate;
                break;
            case 'GENERATIVE':
                modelAnalysisCallBillingSecureRate = this.generativeAnalysisCallBillingSecureRate;
                modelAnalysisTextBillingSecureRate = this.generativeAnalysisTextBillingSecureRate;
                break;
        }
        let cognitiveAnalysisTotalAveragePhrases = 0;
        cognitiveAnalysisTotalAveragePhrases = (this.processCallPhrases * (1 + modelAnalysisCallBillingSecureRate))
            +
                (this.processTextPhrases * (1 + modelAnalysisTextBillingSecureRate));
        return cognitiveAnalysisTotalAveragePhrases;
    }
    GetModelAnalysisTotalAveragePhrasesFromNone(estimatedRequests, analysisType) {
        let modelAnalysisCallBillingSecureRate = 0;
        let modelAnalysisTextBillingSecureRate = 0;
        let modelAnalysisTotalAveragePhrases = 0;
        switch (analysisType) {
            case 'COGNITIVE':
                modelAnalysisCallBillingSecureRate = this.cognitiveAnalysisCallBillingSecureRate;
                modelAnalysisTextBillingSecureRate = this.cognitiveAnalysisTextBillingSecureRate;
                break;
            case 'GENERATIVE':
                modelAnalysisCallBillingSecureRate = this.generativeAnalysisCallBillingSecureRate;
                modelAnalysisTextBillingSecureRate = this.generativeAnalysisTextBillingSecureRate;
                break;
        }
        modelAnalysisTotalAveragePhrases += (estimatedRequests.modelRequestsFromCallTime || 0) * (1 + modelAnalysisCallBillingSecureRate);
        modelAnalysisTotalAveragePhrases += (estimatedRequests.modelRequestFromCallAlreadyPhrases || 0) * (1 + modelAnalysisCallBillingSecureRate);
        modelAnalysisTotalAveragePhrases += (estimatedRequests.modelRequestsFromTextRawChar || 0) * (1 + modelAnalysisTextBillingSecureRate);
        modelAnalysisTotalAveragePhrases += (estimatedRequests.modelRequestsFromTextAlreadyPhrases || 0) * (1 + modelAnalysisTextBillingSecureRate);
        return modelAnalysisTotalAveragePhrases;
    }
}
exports.BillingVCCRates = BillingVCCRates;
class BillingMovement {
    constructor(startDate, endDate, accountId = null, subAccountId = null, vcc = null, type = null) {
        this.startDate = startDate;
        this.endDate = endDate;
        this.accountId = accountId;
        this.subAccountId = subAccountId;
        this.vcc = vcc;
        this.type = type;
    }
}
exports.BillingMovement = BillingMovement;
