"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TextMessageFromI6Data = exports.ExecutionVCCQuotes = exports.VCCQuote = void 0;
class VCCQuote {
    constructor(vcc = null, available = 0) {
        this.vcc = vcc;
        this.available = available;
        this.used = 0;
    }
    get reserved() {
        let maxValue = 20;
        let value = Math.ceil(this.available * 15 / 100);
        return value <= maxValue ? value : maxValue;
    }
}
exports.VCCQuote = VCCQuote;
class ExecutionVCCQuotes {
    constructor() {
        this.quotes = [];
    }
    GetVCCFreeAvailableQuote(vcc) {
        let quote = this.quotes.find(q => q.vcc === vcc);
        return quote.available - quote.reserved;
    }
    GetVCCTotalAvailableQuote(vcc) {
        let quote = this.quotes.find(q => q.vcc === vcc);
        return quote.available;
    }
    GetVCCUsedQuote(vcc) {
        return this.quotes.find(q => q.vcc === vcc).used;
    }
    GetAllUsedQuote() {
        return this.quotes.reduce((acc, obj) => { return acc + obj.used; }, 0);
    }
    IncreaseVCCUsedQuote(vcc, use) {
        let quote = this.quotes.find(q => q.vcc === vcc);
        quote.used += use;
    }
}
exports.ExecutionVCCQuotes = ExecutionVCCQuotes;
class TextMessageFromI6Data {
    constructor() {
        this.userId = null;
        this.channel = null;
        this.fullMsg = null;
        this.msgTime = null;
        this.msgDate = null;
        this.msgNumber = null;
    }
}
exports.TextMessageFromI6Data = TextMessageFromI6Data;
