"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.FilePath = exports.ProcessInteraction = exports.ProcessEvaluationPlan = exports.ProcessAudios = exports.ProcessAudioTranscription = exports.ProcessAudio = exports.LinguisticProcessStatus = exports.ProcessSummary = exports.ProcessFilter = exports.Process = void 0;
class Process {
    constructor(vcc, name, description, clientId, status, type, startDate, endDate, minDurationTime, maxDurationTime, environment, environmentType, queryId, queryDataId, queryDataIdDate, createdDate, createdByUserId, lastModifiedDate, lastModifiedByUserId) {
        this.vcc = vcc;
        this.name = name;
        this.description = description;
        this.clientId = clientId;
        this.status = status;
        this.type = type;
        this.startDate = startDate;
        this.endDate = endDate;
        this.minDurationTime = minDurationTime;
        this.maxDurationTime = maxDurationTime;
        this.environment = environment;
        this.environmentType = environmentType;
        this.queryId = queryId;
        this.queryDataId = queryDataId;
        this.queryDataIdDate = queryDataIdDate;
        this.createdDate = createdDate;
        this.createdByUserId = createdByUserId;
        this.lastModifiedDate = lastModifiedDate;
        this.lastModifiedByUserId = lastModifiedByUserId;
        this.processType = null;
        this.selected = false;
        this.start = false;
        this.processFilters = [];
        this.dictionaryId = null;
        this.retranscription = false;
        this.diarization = true;
        this.channelchange = false;
        this.batchScheduleId = null;
        this.scheduleData = null;
    }
}
exports.Process = Process;
class ProcessFilter {
    constructor(processId, key, value, createdDate, createdByUserId, lastModifiedDate, lastModifiedByUserId) {
        this.processId = processId;
        this.key = key;
        this.value = value;
        this.createdDate = createdDate;
        this.createdByUserId = createdByUserId;
        this.lastModifiedDate = lastModifiedDate;
        this.lastModifiedByUserId = lastModifiedByUserId;
        this.selected = false;
    }
}
exports.ProcessFilter = ProcessFilter;
class ProcessSummary {
    constructor(vcc, processId, silenceTime, averageSilenceTime, durationTime, averageDurationTime, durationTimeRate, validDurationTime) {
        this.vcc = vcc;
        this.processId = processId;
        this.silenceTime = silenceTime;
        this.averageSilenceTime = averageSilenceTime;
        this.durationTime = durationTime;
        this.averageDurationTime = averageDurationTime;
        this.durationTimeRate = durationTimeRate;
        this.validDurationTime = validDurationTime;
    }
}
exports.ProcessSummary = ProcessSummary;
class LinguisticProcessStatus {
    constructor(vcc, processId, status, toTranscribe, transcribed, percentage) {
        this.vcc = vcc;
        this.processId = processId;
        this.status = status;
        this.toTranscribe = toTranscribe;
        this.transcribed = transcribed;
        this.percentage = percentage;
    }
}
exports.LinguisticProcessStatus = LinguisticProcessStatus;
class ProcessAudio {
    constructor(id, number, name, processId, silennceTime, durationTime, category1, category2, category3, agent, description, environment, createdDate) {
        this.id = id;
        this.number = number;
        this.name = name;
        this.processId = processId;
        this.silennceTime = silennceTime;
        this.durationTime = durationTime;
        this.category1 = category1;
        this.category2 = category2;
        this.category3 = category3;
        this.agent = agent;
        this.description = description;
        this.environment = environment;
        this.createdDate = createdDate;
    }
}
exports.ProcessAudio = ProcessAudio;
class ProcessAudioTranscription {
    constructor(id, section, number, processId, silennceTime, durationTime, durationLinguisticTime, category1, category2, category3, agent, description, environment, environmentType, isTranscribed, isSubrayed, createdDate) {
        this.id = id;
        this.section = section;
        this.number = number;
        this.processId = processId;
        this.silennceTime = silennceTime;
        this.durationTime = durationTime;
        this.durationLinguisticTime = durationLinguisticTime;
        this.category1 = category1;
        this.category2 = category2;
        this.category3 = category3;
        this.agent = agent;
        this.description = description;
        this.environment = environment;
        this.environmentType = environmentType;
        this.isTranscribed = isTranscribed;
        this.isSubrayed = isSubrayed;
        this.createdDate = createdDate;
    }
}
exports.ProcessAudioTranscription = ProcessAudioTranscription;
class ProcessAudios {
    constructor(vcc, processId, audioId, section, part, createdDate, createdByUserId, lastModifiedDate, lastModifiedByUserId) {
        this.vcc = vcc;
        this.processId = processId;
        this.audioId = audioId;
        this.section = section;
        this.part = part;
        this.createdDate = createdDate;
        this.createdByUserId = createdByUserId;
        this.lastModifiedDate = lastModifiedDate;
        this.lastModifiedByUserId = lastModifiedByUserId;
    }
}
exports.ProcessAudios = ProcessAudios;
class ProcessEvaluationPlan {
    constructor() {
        this.evaluationFormatId = null;
    }
}
exports.ProcessEvaluationPlan = ProcessEvaluationPlan;
class ProcessInteraction {
    constructor(vcc, processId, id) {
        this.vcc = vcc;
        this.processId = processId;
        this.id = id;
        this.batchTypeName = null;
        this.batchTypeId = null;
        this.relativePath = null;
        this.dictionaryId = null;
        this.bucket = null;
        this.transcriptionApi = null;
        this.transcriptionToken = null;
        this.transcriptionProtocol = null;
        this.isDiariced = false;
        this.channelsChanged = false;
        this.retranscription = 0;
        this.diarization = 1;
        this.channelchange = 0;
    }
}
exports.ProcessInteraction = ProcessInteraction;
class FilePath {
}
exports.FilePath = FilePath;
