"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ProcessScheduleExecution = exports.ScheduleExecution = exports.ScheduleData = exports.ScheduleSummary = void 0;
class ScheduleSummary {
    constructor() {
        this.vcc = null;
        this.id = null;
        this.batchType = null;
        this.frequency = null;
        this.startDate = null;
        this.endDate = null;
        this.firstExecutionDate = null;
        this.lastExecutionDate = null;
        this.total = null;
        this.preparing = null;
        this.running = null;
        this.cancelled = null;
        this.finished = null;
        this.succeed = null;
        this.error = null;
        this.failed = null;
        this.lastExecutionStatus = null;
        this.createdByUserId = null;
        this.createdDate = null;
    }
}
exports.ScheduleSummary = ScheduleSummary;
class ScheduleData {
    constructor() {
        this.vcc = null;
        this.id = null;
        this.batchType = null;
        this.frequency = null;
        this.weekDay = null;
        this.monthDay = null;
        this.daysInterval = null;
        this.hoursInterval = null;
        this.executionHour = null;
        this.daysToExpire = null;
        this.firstExecutionDate = null;
        this.lastExecutionDate = null;
        this.maxLastExecutionDate = null;
        this.executionDelay = 0;
        this.includeHistoricalData = false;
        this.startDate = null;
        this.endDate = null;
        this.executionList = [];
        this.batchData = null;
        this.processFiltersId = null;
        this.status = null;
        this.createdByUserId = null;
    }
}
exports.ScheduleData = ScheduleData;
class ScheduleExecution {
    constructor() {
        this.vcc = null;
        this.id = null;
        this.batchScheduleId = null;
        this.batchId = null;
        this.executionDate = null;
        this.order = null;
        this.status = null;
        this.createdByUserId = null;
        this.createdDate = null;
        this.lastModifiedDate = null;
        this.lastModifiedByUserId = null;
    }
}
exports.ScheduleExecution = ScheduleExecution;
class ProcessScheduleExecution extends ScheduleExecution {
    constructor() {
        super(...arguments);
        this.name = null;
        this.description = null;
        this.clientId = null;
        this.percentage = null;
        this.statusDescription = null;
        this.status = null;
        this.startDate = null;
        this.endDate = null;
        this.minDurationTime = null;
        this.maxDurationTime = null;
        this.language = null;
        this.environment = null;
    }
}
exports.ProcessScheduleExecution = ProcessScheduleExecution;
