"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Item = exports.TemplateByAPI = exports.GenericTemplateQuery = exports.TemplateThemeItemEntity = exports.TemplateThemeItem = exports.TemplateTheme = exports.Template = void 0;
class Template {
    constructor(type, name, description, template, category, createdDate, createdByUserId, lastModifiedDate, lastModifiedByUserId) {
        this.type = type;
        this.name = name;
        this.description = description;
        this.template = template;
        this.category = category;
        this.createdDate = createdDate;
        this.createdByUserId = createdByUserId;
        this.lastModifiedDate = lastModifiedDate;
        this.lastModifiedByUserId = lastModifiedByUserId;
        this.vcc = null;
        this.selected = false;
        this.templateThemes = [];
        this.templateThemeItems = [];
        this.genericTemplateQueries = [];
        this.modelLanguages = null;
        this.scheduleData = null;
    }
}
exports.Template = Template;
class TemplateTheme {
    constructor(templateId, id, order, description, category1, category2, createdDate, createdByUserId, lastModifiedDate, lastModifiedByUserId) {
        this.templateId = templateId;
        this.id = id;
        this.order = order;
        this.description = description;
        this.category1 = category1;
        this.category2 = category2;
        this.createdDate = createdDate;
        this.createdByUserId = createdByUserId;
        this.lastModifiedDate = lastModifiedDate;
        this.lastModifiedByUserId = lastModifiedByUserId;
        this.selected = false;
        this.items = [];
        this.isNegative = false;
        this.analysisType = 'SEMANTIC';
    }
}
exports.TemplateTheme = TemplateTheme;
class TemplateThemeItem {
    constructor(templateId, templateThemeId, id, query, createdDate, createdByUserId, lastModifiedDate, lastModifiedByUserId) {
        this.templateId = templateId;
        this.templateThemeId = templateThemeId;
        this.id = id;
        this.query = query;
        this.createdDate = createdDate;
        this.createdByUserId = createdByUserId;
        this.lastModifiedDate = lastModifiedDate;
        this.lastModifiedByUserId = lastModifiedByUserId;
        this.selected = false;
        this.acceptancePercentage = 0;
        this.order = null;
    }
}
exports.TemplateThemeItem = TemplateThemeItem;
class TemplateThemeItemEntity {
    constructor() {
        this.templateId = null;
        this.templateThemeId = null;
        this.templateThemeItemId = null;
        this.entityId = null;
        this.entityName = null;
        this.acceptancePercentage = 0;
        this.order = null;
        this.createdDate = null;
        this.createdByUserId = null;
        this.lastModifiedDate = null;
        this.lastModifiedByUserId = null;
    }
}
exports.TemplateThemeItemEntity = TemplateThemeItemEntity;
class GenericTemplateQuery {
    constructor(templateId, id, query, createdDate, createdByUserId, lastModifiedDate, lastModifiedByUserId) {
        this.templateId = templateId;
        this.id = id;
        this.query = query;
        this.createdDate = createdDate;
        this.createdByUserId = createdByUserId;
        this.lastModifiedDate = lastModifiedDate;
        this.lastModifiedByUserId = lastModifiedByUserId;
        this.selected = false;
    }
}
exports.GenericTemplateQuery = GenericTemplateQuery;
class TemplateByAPI {
    constructor(name, description, template, category, type, items, createdDate, createdByUserId, lastModifiedDate, lastModifiedByUserId) {
        this.name = name;
        this.description = description;
        this.template = template;
        this.category = category;
        this.type = type;
        this.items = items;
        this.createdDate = createdDate;
        this.createdByUserId = createdByUserId;
        this.lastModifiedDate = lastModifiedDate;
        this.lastModifiedByUserId = lastModifiedByUserId;
        this.templateThemes = [];
        this.templateThemeItems = [];
    }
}
exports.TemplateByAPI = TemplateByAPI;
class Item {
    constructor(item, order, type, query, items) {
        this.item = item;
        this.order = order;
        this.type = type;
        this.query = query;
        this.items = items;
    }
}
exports.Item = Item;
