"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.VCCProduct = exports.RequestData = exports.ProductVCC = exports.VCCAux = exports.IntegratedVCC = exports.VCC = void 0;
class VCC {
    constructor(vcc, id, description, country, language, timeZone, createdDate, createdByUserId, lastModifiedDate, lastModifiedByUserId) {
        this.vcc = vcc;
        this.id = id;
        this.description = description;
        this.country = country;
        this.language = language;
        this.timeZone = timeZone;
        this.createdDate = createdDate;
        this.createdByUserId = createdByUserId;
        this.lastModifiedDate = lastModifiedDate;
        this.lastModifiedByUserId = lastModifiedByUserId;
        this.enableGenerativeEngine = false;
        this.enableRealTime = false;
        this.selected = false;
        this.changedCognitiveEngine = false;
        this.deleteDataDays = 360;
        this.totalNlu = 0;
        this.totalIntent = 0;
        this.totalUtterance = 0;
        this.totalEntity = 0;
        this.inUseModels = false;
    }
}
exports.VCC = VCC;
class IntegratedVCC {
}
exports.IntegratedVCC = IntegratedVCC;
class VCCAux {
    constructor(vcc, id, description, country, language, timeZone, products, channels, createdDate, createdByUserId, lastModifiedDate, lastModifiedByUserId) {
        this.vcc = vcc;
        this.id = id;
        this.description = description;
        this.country = country;
        this.language = language;
        this.timeZone = timeZone;
        this.products = products;
        this.channels = channels;
        this.createdDate = createdDate;
        this.createdByUserId = createdByUserId;
        this.lastModifiedDate = lastModifiedDate;
        this.lastModifiedByUserId = lastModifiedByUserId;
        this.type = null;
        this.cognitiveEngine = null;
        this.enableGenerativeEngine = false;
        this.selected = false;
        this.cognitiveEngineCharsLimit = 0;
        this.enableRealTime = false;
    }
}
exports.VCCAux = VCCAux;
class ProductVCC {
    constructor(accountId = '', subAccountId = '', products = [], vcc, availableBalance, asignableBalance, transcriptionRatePerHour = 0.00001, transcriptionRatePerSecond = 0.00001, semanticAnalysisRatePerTransaction = 0.00001, cognitiveAnalysisRatePerTransaction = 0.00001, createdDate, createdByUserId, lastModifiedDate, lastModifiedByUserId, timeStamp) {
        this.accountId = accountId;
        this.subAccountId = subAccountId;
        this.products = products;
        this.vcc = vcc;
        this.availableBalance = availableBalance;
        this.asignableBalance = asignableBalance;
        this.transcriptionRatePerHour = transcriptionRatePerHour;
        this.transcriptionRatePerSecond = transcriptionRatePerSecond;
        this.semanticAnalysisRatePerTransaction = semanticAnalysisRatePerTransaction;
        this.cognitiveAnalysisRatePerTransaction = cognitiveAnalysisRatePerTransaction;
        this.createdDate = createdDate;
        this.createdByUserId = createdByUserId;
        this.lastModifiedDate = lastModifiedDate;
        this.lastModifiedByUserId = lastModifiedByUserId;
        this.timeStamp = timeStamp;
    }
}
exports.ProductVCC = ProductVCC;
class RequestData {
}
exports.RequestData = RequestData;
class VCCProduct {
    constructor(product, availableLicense, assign, updatedValue) {
        this.product = product;
        this.availableLicense = availableLicense;
        this.assign = assign;
        this.updatedValue = updatedValue;
        this.selected = false;
    }
}
exports.VCCProduct = VCCProduct;
