"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AverageGroupRatingNormService = void 0;
const log4js = require("log4js");
const mssql_service_1 = require("../db/mssql.service");
const promises_shared_1 = require("../shared/promises.shared");
let logger = log4js.getLogger('ServerScripts');
function AverageGroupRatingNormService(app) {
    app.get('/api/average_group_rating_norm/get_average_group_rating_norm/:initialDate/:endDate/:campaigns/:evaluationFormats/:evaluationPlans/:agents/:idGroup/:idSubGroup/:idAbility/:auditors?', (req, res, next) => {
        logger.info('Se recibio ' + req.method + ' para \'' + req.path + '\'');
        let instance = res.locals.instance;
        let initialDateString = req.params.initialDate ? req.params.initialDate : null;
        let endDateString = req.params.endDate ? req.params.endDate : null;
        let initialDate = initialDateString ? new Date(initialDateString) : null;
        let endDate = endDateString ? new Date(endDateString) : null;
        let campaigns = (req.params.campaigns && req.params.campaigns !== 'null' && req.params.campaigns !== 'undefined') ? req.params.campaigns : null;
        let evaluationFormats = (req.params.evaluationFormats && req.params.evaluationFormats !== 'null' && req.params.evaluationFormats !== 'undefined') ? req.params.evaluationFormats : null;
        let evaluationPlans = (req.params.evaluationPlans && req.params.evaluationPlans !== 'null' && req.params.evaluationPlans !== 'undefined') ? req.params.evaluationPlans : null;
        let agents = (req.params.agents && req.params.agents !== 'null' && req.params.agents !== 'undefined') ? req.params.agents : null;
        let idGroup = (req.params.idGroup && req.params.idGroup !== 'null' && req.params.idGroup !== '0') ? req.params.idGroup : null;
        let idSubGroup = (req.params.idSubGroup && req.params.idSubGroup !== 'null' && req.params.idSubGroup !== '0') ? req.params.idSubGroup : null;
        let idAbility = (req.params.idAbility && req.params.idAbility !== 'null' && req.params.idAbility !== '0') ? req.params.idAbility : null;
        let auditors = (req.params.auditors && req.params.auditors !== 'null' && req.params.auditors !== 'undefined') ? req.params.auditors : null;
        promises_shared_1.DummyPromise()
            .then(result => {
            if (initialDateString && initialDateString !== 'null' && endDateString && endDateString !== 'null') {
                return mssql_service_1.MSSql.GetAverageGroupRatingNorm(instance, initialDate, endDate, campaigns, evaluationFormats, evaluationPlans, agents, idGroup, idSubGroup, idAbility, auditors);
            }
            else {
                return null;
            }
        }).then(resultAverageGroupRating => {
            if (res.headersSent)
                return;
            res.json({ status: true, description: 'SERVER_SUCCESS_MESSAGE', data: resultAverageGroupRating });
        }).catch(err => {
            let clientMsg = (typeof err === 'string' ? err : 'CANNOT_PROCESS_REQUEST');
            let errorMsg = (typeof err === 'string' ? err : err.message || err.description || 'SERVER_ERROR_UNKNOWN_MESSAGE');
            logger.error('Error al procesar \'' + req.path + '\': ' + errorMsg);
            if (res.headersSent)
                return;
            res.json({ status: false, description: clientMsg, error: errorMsg });
        });
    });
}
exports.AverageGroupRatingNormService = AverageGroupRatingNormService;
