"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.init = void 0;
const log4js = require("log4js");
let logger = log4js.getLogger('ServerScripts');
const auth_service_1 = require("./auth.service");
const batch_service_1 = require("./batch.service");
const batch_schedule_service_1 = require("./batch-schedule.service");
const custom_field_service_1 = require("./custom-field.service");
const diarization_service_1 = require("./diarization.service");
const dictionary_service_1 = require("./dictionary.service");
const efectivity_plan_service_1 = require("./efectivity-plan.service");
const entity_service_1 = require("./entity.service");
const generative_service_1 = require("./generative.service");
const home_service_1 = require("./home.service");
const profile_image_service_1 = require("./profile-image.service");
const report_service_1 = require("./report.service");
const role_service_1 = require("./role.service");
const task_service_1 = require("./task.service");
const team_performance_service_1 = require("./team-performance.service");
const user_service_1 = require("./user.service");
const api_user_service_1 = require("./api-user.service");
const client_service_1 = require("./client.service");
const process_service_1 = require("./process.service");
const idatha_service_1 = require("./idatha.service");
const feeling_service_1 = require("./feeling.service");
const category_service_1 = require("./category.service");
const neuro_linguistic_programming_service_1 = require("./neuro-linguistic-programming.service");
const template_service_1 = require("./template.service");
const generic_template_service_1 = require("./generic-template.service");
const generic_query_service_1 = require("./generic-query.service");
const nlu_service_1 = require("./nlu.service");
const intent_service_1 = require("./intent.service");
const utterance_service_1 = require("./utterance.service");
const train_service_1 = require("./train.service");
const environment_service_1 = require("./environment.service");
const allegro_service_1 = require("./allegro.service");
const audio_service_1 = require("./audio.service");
const exception_service_1 = require("./exception.service");
const country_service_1 = require("./country.service");
const tag_service_1 = require("./tag.service");
const study_service_1 = require("./study.service");
const word_blacklist_service_1 = require("./word-blacklist.service");
const vcc_service_1 = require("./vcc.service");
const linguistic_service_1 = require("./linguistic.service");
const platform_service_1 = require("./platform.service");
const account_service_1 = require("./account.service");
const ability_service_1 = require("./ability.service");
const agents_service_1 = require("./agents.service");
const attentionlevel_service_1 = require("./attentionlevel.service");
const average_group_rating_service_1 = require("./average-group-rating.service");
const campain_service_1 = require("./campain.service");
const evaluation_format_service_1 = require("./evaluation-format.service");
const interaction_service_1 = require("./interaction.service");
const tipification_service_1 = require("./tipification.service");
const top_best_agents_service_1 = require("./top-best-agents.service");
const evaluation_plan_service_1 = require("./evaluation-plan.service");
const evaluation_service_1 = require("./evaluation.service");
const group_service_1 = require("./group.service");
const auditor_service_1 = require("./auditor.service");
const subgroup_service_1 = require("./subgroup.service");
const average_group_rating_norm_service_1 = require("./average-group-rating-norm.service");
const top_worst_agents_service_1 = require("./top-worst-agents.service");
const interaction_type_service_1 = require("./interaction-type.service");
const campaign_fulfillment_service_1 = require("./campaign-fulfillment.service");
const workgroup_service_1 = require("./workgroup.service");
const workgroupsupervisor_service_1 = require("./workgroupsupervisor.service");
const disposition_code_service_1 = require("./disposition-code.service");
const interactions_by_type_service_1 = require("./interactions-by-type.service");
const io_service_1 = require("./io.service");
const global_search_service_1 = require("./global-search.service");
function init(app) {
    logger.info('Incializando servicios');
    auth_service_1.AuthService(app);
    batch_service_1.BatchService(app);
    batch_schedule_service_1.BatchScheduleService(app);
    custom_field_service_1.CustomFieldService(app);
    diarization_service_1.DiarizationService(app);
    dictionary_service_1.DictionaryService(app);
    efectivity_plan_service_1.EfectivityPlanService(app);
    entity_service_1.EntityService(app);
    generative_service_1.GenerativeService(app);
    home_service_1.HomeService(app);
    profile_image_service_1.ProfileImageService(app);
    report_service_1.ReportService(app);
    role_service_1.RoleService(app);
    task_service_1.TaskService(app);
    team_performance_service_1.TeamPerformanceService(app);
    user_service_1.UserService(app);
    api_user_service_1.ApiUserService(app);
    client_service_1.ClientService(app);
    country_service_1.CountryService(app);
    process_service_1.ProcessService(app);
    idatha_service_1.IdathaService(app);
    feeling_service_1.FeelingService(app);
    category_service_1.CategoryService(app);
    neuro_linguistic_programming_service_1.NeuroLinguisticProgrammingService(app);
    template_service_1.TemplateService(app);
    generic_template_service_1.GenericTemplateService(app);
    generic_query_service_1.GenericQueryService(app);
    nlu_service_1.NLUService(app);
    intent_service_1.IntentService(app);
    utterance_service_1.UtteranceService(app);
    train_service_1.TrainService(app);
    environment_service_1.EnvironmentService(app);
    allegro_service_1.AllegroService(app);
    audio_service_1.AudioService(app);
    exception_service_1.ExceptionService(app);
    tag_service_1.TagService(app);
    study_service_1.StudyService(app);
    word_blacklist_service_1.WordBlacklistService(app);
    tag_service_1.TagService(app);
    vcc_service_1.VCCService(app);
    linguistic_service_1.LinguisticService(app);
    platform_service_1.PlatformService(app);
    account_service_1.AccountService(app);
    ability_service_1.AbilityService(app);
    agents_service_1.AgentsService(app);
    attentionlevel_service_1.AttentionLevelService(app);
    auditor_service_1.AuditorService(app);
    average_group_rating_norm_service_1.AverageGroupRatingNormService(app);
    average_group_rating_service_1.AverageGroupRatingService(app);
    campain_service_1.CampainService(app);
    campaign_fulfillment_service_1.CampaignFulfillmentService(app);
    disposition_code_service_1.DispositionCodeService(app);
    evaluation_format_service_1.EvaluationFormatService(app);
    evaluation_plan_service_1.EvaluationPlanService(app);
    evaluation_service_1.EvaluationService(app);
    group_service_1.GroupService(app);
    interactions_by_type_service_1.InteractionsByTypeService(app);
    interaction_service_1.InteractionService(app);
    interaction_type_service_1.InteractionTypeService(app);
    io_service_1.IOService(app);
    subgroup_service_1.SubgroupService(app);
    tipification_service_1.TipificationService(app);
    top_best_agents_service_1.TopBestAgentsService(app);
    top_worst_agents_service_1.TopWorstAgentsService(app);
    workgroup_service_1.WorkGroupService(app);
    workgroupsupervisor_service_1.WorkGroupSupervisorService(app);
    global_search_service_1.GlobalSearchService(app);
}
exports.init = init;
