"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SortObjectArrayByShuffle = exports.SortObjectArrayByValue = exports.GetSumFromObjectArray = exports.GetUniqueFromObjectArray = exports.GetUniqueFromArray = exports.GetCompareItemsFromObjectArray = void 0;
function GetCompareItemsFromObjectArray(oldArr, newArr, keyPropertyOA, keyPropertyNA) {
    if (!keyPropertyNA)
        keyPropertyNA = keyPropertyOA;
    if (!oldArr)
        oldArr = [];
    if (!newArr)
        newArr = [];
    let newItems = [];
    let oldItems = [];
    let removedItems = [];
    oldArr.map(oa => {
        if (!newArr.find(na => na[keyPropertyNA] === oa[keyPropertyOA]))
            removedItems.push(oa);
        else
            oldItems.push(newArr.find(na => na[keyPropertyNA] === oa[keyPropertyOA]));
    });
    newArr.map(na => {
        if (!oldArr.find(oa => oa[keyPropertyOA] === na[keyPropertyNA]))
            newItems.push(na);
    });
    return {
        new: newItems,
        old: oldItems,
        removed: removedItems
    };
}
exports.GetCompareItemsFromObjectArray = GetCompareItemsFromObjectArray;
function GetUniqueFromArray(arr) {
    let reducedArray = arr.reduce((unique, item) => {
        return unique.includes(item) ? unique : [...unique, item];
    }, []);
    return reducedArray;
}
exports.GetUniqueFromArray = GetUniqueFromArray;
function GetUniqueFromObjectArray(arr, value) {
    const unique = arr
        .map(e => e[value])
        .map((e, i, final) => final.indexOf(e) === i && i)
        .filter(e => arr[e]).map(e => arr[e]);
    return unique;
}
exports.GetUniqueFromObjectArray = GetUniqueFromObjectArray;
function GetSumFromObjectArray(arr, property) {
    let total = 0;
    total = arr.map(item => item[property]).reduce((prev, curr) => prev + curr, 0);
    return total;
}
exports.GetSumFromObjectArray = GetSumFromObjectArray;
function SortObjectArrayByValue(arr, property, sortType) {
    let sortedObjectArray = [];
    switch (sortType) {
        case 'A':
            sortedObjectArray = arr.sort((a, b) => (a[property] < b[property] ? -1 : 1));
            break;
        case 'D':
            sortedObjectArray = arr.sort((a, b) => (a[property] > b[property] ? -1 : 1));
            break;
    }
    return sortedObjectArray;
}
exports.SortObjectArrayByValue = SortObjectArrayByValue;
function SortObjectArrayByShuffle(arr) {
    var currentIndex = arr.length, randomIndex;
    while (0 !== currentIndex) {
        randomIndex = Math.floor(Math.random() * currentIndex);
        currentIndex--;
        [arr[currentIndex], arr[randomIndex]] = [
            arr[randomIndex], arr[currentIndex]
        ];
    }
    return arr;
}
exports.SortObjectArrayByShuffle = SortObjectArrayByShuffle;
