"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CompleteLength = exports.ConvertRangeHourNumber = exports.FormatUTC = exports.ConvertDateTimeZone = void 0;
const moment = require("moment");
const timezone = require("moment-timezone");
function ConvertDateTimeZone(date, hour, timeZone) {
    let arrayDate = date.split('-');
    let objDate = { year: arrayDate[0],
        month: parseInt(arrayDate[1]) - 1,
        day: arrayDate[2],
        hour: hour };
    let dateTimeZone = timezone.tz(objDate, timeZone).utc().format('YYYY-MM-DD HH:mm:ss');
    return dateTimeZone;
}
exports.ConvertDateTimeZone = ConvertDateTimeZone;
function FormatUTC(date) {
    let dateTimeZone = moment.utc(date).format('YYYY-MM-DD HH:mm:ss');
    return dateTimeZone;
}
exports.FormatUTC = FormatUTC;
function ConvertRangeHourNumber(hour) {
    let arrayHour = hour.split('-');
    let hourNumber = parseInt((arrayHour[0] && arrayHour[0].length > 2) ? arrayHour[0].substr(0, 2) : '0');
    return hourNumber.toString();
}
exports.ConvertRangeHourNumber = ConvertRangeHourNumber;
function CompleteLength(input, length, padding) {
    let str = input + '';
    return (length <= str.length) ? str : CompleteLength(str + padding, length, padding);
}
exports.CompleteLength = CompleteLength;
