"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.GetDiskUsage = void 0;
const log4js = require("log4js");
const check_disk_space_1 = require("check-disk-space");
const promises_shared_1 = require("./promises.shared");
const server_config_1 = require("../config/server.config");
let logger = log4js.getLogger('ServerScripts');
function GetDiskUsage(path) {
    path ?? (path = server_config_1.SERVER_DISK_LOGIC_LOCATION);
    return promises_shared_1.DummyPromise()
        .then(_ => {
        return check_disk_space_1.default(path);
    })
        .then((diskSpace) => {
        logger.info('[dislk-space-check:GetDiskUsage] Result:', diskSpace);
        return Promise.resolve(diskSpace);
    })
        .catch(error => {
        logger.error('[dislk-space-check:GetDiskUsage] error:', error);
        return Promise.reject(error);
    });
}
exports.GetDiskUsage = GetDiskUsage;
