"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PromiseWait = exports.PromiseTimeOut = exports.SleepPromise = exports.DummyPromise = void 0;
function DummyPromise() {
    return new Promise(function (resolve, reject) {
        resolve(true);
    });
}
exports.DummyPromise = DummyPromise;
function SleepPromise(secondTime) {
    return new Promise(function (resolve, reject) {
        setTimeout(resolve, (1000 * secondTime));
    });
}
exports.SleepPromise = SleepPromise;
function PromiseTimeOut(ms, promise) {
    let timeout = new Promise((resolve, reject) => {
        let id = setTimeout(() => {
            clearTimeout(id);
            resolve(null);
        }, ms);
    });
    return Promise.race([
        promise,
        timeout
    ]);
}
exports.PromiseTimeOut = PromiseTimeOut;
function PromiseWait(ms, returnValue) {
    if (!ms || isNaN(ms))
        return Promise.resolve(returnValue);
    return new Promise((resolve, reject) => {
        let timer = setTimeout(() => {
            clearTimeout(timer);
            resolve(returnValue);
        }, ms);
    });
}
exports.PromiseWait = PromiseWait;
