"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ProcessInRunning = void 0;
const logger_config_1 = require("../config/logger.config");
const findProcess = require("../shared/manager-process");
const log4js = require("log4js");
log4js.configure(logger_config_1.LOGGER_CONFIG);
let logger = log4js.getLogger('Task');
function ProcessInRunning() {
    let processRunning = [];
    return findProcess.FindProcess('node')
        .then((list) => {
        let arrayPromise = [];
        let onProgress = false;
        let ubuntuNodeProcess = { name: 'sh', cmd: '/bin/sh -c node ' };
        let windowsNodeProcess = { name: 'node.exe', cmd: 'node  ' };
        processRunning = list.filter((element) => {
            onProgress = ((element.name === ubuntuNodeProcess.name || element.name === windowsNodeProcess.name)
                && (__filename.indexOf(element.cmd.replace(windowsNodeProcess.cmd, '')) > -1 || __filename.indexOf(element.cmd.replace(ubuntuNodeProcess.cmd, '')) > -1)) ? true : false;
            if (onProgress && element && element.time > 900) {
                logger.info('[FindProcess] DELETED', element.id, element);
                arrayPromise.push(findProcess.KillTask(element.pid));
            }
            return onProgress;
        });
        logger.info('[FindProcess] total Task on progress', (processRunning && processRunning.length ? processRunning.length : 0));
        return Promise.all(arrayPromise);
    }).then(_ => {
        if (processRunning && ([0, 1].includes(processRunning.length))) {
            logger.info('[FindProcess] RUN');
            return false;
        }
        logger.info('[FindProcess] CANCEL EXEC');
        return true;
    }).catch(err => {
        logger.error('[FindProcess] getting error:', err);
        return Promise.resolve(false);
    });
}
exports.ProcessInRunning = ProcessInRunning;
